SystemOrganization addCategory: #'OB-Standard-Actors'!
SystemOrganization addCategory: #'OB-Standard-Browsers'!
SystemOrganization addCategory: #'OB-Standard-Nodes'!
SystemOrganization addCategory: #'OB-Standard-Notifications'!
SystemOrganization addCategory: #'OB-Standard-Tests'!
SystemOrganization addCategory: #'OB-Standard-Utilities'!

!SystemOrganizer methodsFor: '*ob-standard-testing' stamp: 'cwp 9/18/2004 23:58'!
isClassOrganizer
	^ false! !

OBBrowserTest subclass: #OBCodeBrowserTest
	instanceVariableNames: 'damage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodOne
	^ 'one
	^ 1'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testCreateClassFromClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusDDefinition.
	damage add: #Definition ofClass: #BogusD.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD.! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: ''!
resources
	^ Array with: BogusSnapshotResource! !

OBCodeBrowserTest subclass: #OBImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/10/2004 21:28'!
node
	^ OBEnvironmentNode forImage! !

OBImageBrowserTest subclass: #OBAltImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBAltImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 22:05'!
metagraph
	^OBCodeGraphInitializer new hierarchicalImage! !

!OBAltImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 21:53'!
bogusClassNames
	^ #('BogusA' ' BogusE' 'BogusB' 'BogusC')! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:40'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/12/2004 23:40'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: {self bogusCategoryName}.
	self assertTextIs: ''.
	! !

!OBImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/10/2004 21:27'!
browserClass
	^ OBSystemBrowser! !

OBImageBrowserTest subclass: #OBHierImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/12/2004 23:44'!
testSelectCategory
	"Not applicable to the hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:30'!
testEditClass
	self selectBogusCategory.
	self select: self bogusEName.
	damage add: #Definition ofClass: #BogusE.
	self setText: self bogusEDefinition.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: self bogusEName.
	self assert: BogusE instVarNames = #(foo)! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:58'!
bogusAName
	^ '  BogusA'! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:11'!
bogusDDefinition
 ^ 'BogusA subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:34'!
testDeselectFakeA
	self selectBogusCategory.
	self selectBogusA.
	self deselect: self bogusAName.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: '' "for now"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:07'!
testButtonRemoval
	"Not applicable to hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/15/2004 21:13'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: self bogusClassNames.
	self assertTextIs: ''.! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:22'!
bogusClassNames
	^ #('ProtoObject' ' Object' '  BogusA' '   BogusE')! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/15/2004 21:13'!
testEditComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	damage add: #Comment ofClass: #BogusA.
	self setText: self bogusBComment.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: self bogusAName.
	self assert: BogusA comment = self bogusBComment! !

!OBHierImageBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2004 23:32'!
shouldInheritSelectors
	^ true! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:34'!
bogusDName
	^ '   BogusD'! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:33'!
testCreateClassFromClass
	self selectBogusCategory.
	self select: self bogusEName.
	damage add: #Definition ofClass: #BogusD.
	self setText: self bogusDDefinition.
	self assertAListIncludes: {self bogusDName}.
	self assertCurrentItemIs: self bogusDName.! !

!OBHierImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/12/2004 22:47'!
node
	^ OBClassNode on: BogusA! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:31'!
bogusEDefinition
 ^ 'BogusA subclass: #BogusE
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:15'!
testCreateClassFromTemplate
	"doesn't apply for now"! !

!OBHierImageBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/12/2004 23:43'!
selectBogusCategory
	! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/12/2004 23:24'!
testJumpToFakes
	"Not applicable to the hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/12/2004 22:48'!
metagraph
	^ OBCodeGraphInitializer new hierarchy! !

!OBHierImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/13/2004 00:37'!
browserClass
	^ OBHierarchyBrowser! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:29'!
bogusEName
	^ '   BogusE'! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/12/2004 22:10'!
metagraph
	^ OBCodeGraphInitializer new alphabeticalImage! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
selectBogusCategory
	self select: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassBComment
	self deprecated: 'Use #bogusBComment'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:09'!
testCreateClassFromTemplate
	self selectBogusCategory.
	damage add: #Definition ofClass: #BogusD.
	self setText: self bogusDDefinition.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD ! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakePackageName
	self deprecated: 'Use BogusInfo>>packageName'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:23'!
testSelectBogusAClassSide
	self selectBogusCategory.
	self selectBogusA.
	self switchToClassSide.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('capitals').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToCapitals
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'capitals' 
					inClass: BogusA class).
	self assertCurrentItemIs: 'capitals'.
	self assertIsClassSide.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:40'!
bogusCategoryName
	^ BogusInfo baseCategory! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:51'!
bogusAName
	^'BogusA'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
browserResource
	^ self class resources first current! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
runCaseAsFailure: aSemaphore
	SystemChangeNotifier uniqueInstance doSilently: [super runCaseAsFailure: aSemaphore]! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
deselectBogusCategory
	self deselect: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:03'!
testCreateMethodFromMethod
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self methodFour.
	damage add: #four ofClass: #BogusA.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 12/10/2004 21:32'!
setUp
	damage := BogusDamage new.
	model _ self browserClass metaNode: self metagraph node: self node.
	morph _ model morph.
	self forceLayout! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassCDefinition
	self deprecated: 'Use #bogusCDefinition'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/13/2004 00:01'!
selectBogusA
	self select: self bogusAName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testSelectBogusA
	self selectBogusCategory.
	self selectBogusA.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: self bogusATemplate! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
selectBogusPackage
	! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/12/2004 23:55'!
testJumpToFakes
	self selectBogusPackage.
	model jumpTo: (OBClassCategoryNode 
						on: self bogusCategoryName 
						inEnvironment: Smalltalk).
	self assertCurrentItemIs: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
runCase
	SystemChangeNotifier uniqueInstance doSilently: [super runCase]! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodA
	^ 'a
	^ $A'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testColumnClearing
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self switchToClassSide.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('testing' 'capitals').
	self denyAListIncludes: #('letters' 'numbers').
	self denyAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeAComment
	self deprecated: 'Use BogusInfo>>aComment instead'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testDeselectFakeA
	self selectBogusCategory.
	self selectBogusA.
	self deselect: self bogusAName.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: self classTemplate.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/15/2004 21:06'!
testEditComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	self setText: self bogusBComment.
	damage add: #Comment ofClass: #BogusA.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: #BogusA.
	self assert: BogusA comment = self bogusBComment! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:30'!
testSelectOne
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: BogusInfo aOneSource! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
tearDown
	damage repair! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', self bogusPackageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusAClassTemplate
	^  'BogusA class
	instanceVariableNames: '''''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/10/2004 21:16'!
testSelectCategory
	self selectBogusCategory.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: self bogusClassNames.
	self assertTextIs: self classTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToNumbers
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'numbers' 
					inClass: BogusA).
	self assertCurrentItemIs: 'numbers'.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testEditMethod
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.

	damage add: #one ofClass: #BogusA.
	self setText: self altMethodOne.
	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: 11 = BogusA new one! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testMethodChangedElsewhere
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self editText: 'foo'.

	damage add: #one ofClass: #BogusA.
	BogusA compile: self altMethodOne.
	model refresh.

	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: self textMorph hasEditingConflicts
	! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:25'!
testSelectAllMethodCategory
	self selectBogusCategory.
	self selectBogusA.
	self select: '-- all --'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three' 'five' 'a' 'b').
	self assertTextIs: self methodTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testEditClassMethod
	self selectBogusCategory.
	self selectBogusA.
	self switchToClassSide.
	self select: 'capitals'.
	self select: 'a'.
	self setText: self altMethodA.
	damage add: #a ofClass: #BogusA isMeta: true.
	self assertAListMatches: #('a' 'b').
	self assertCurrentItemIs: 'a'.
	self assert: $B = BogusA a! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
switchToComment
	self clickButtonLabeled: '?'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:01'!
testButtonRemoval
	self selectBogusCategory.
	self selectBogusA.
	self deselectBogusCategory.
	self assertNoButtonsVisible! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
altMethodA
	^ 'a
	^ $B'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodFour
	^ 'four
	^ 4'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/10/2004 21:15'!
bogusClassNames
	^BogusInfo baseClassNames! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeATemplate
	self deprecated: 'Use #bogusATemplate instead'! !

!OBCodeBrowserTest methodsFor: 'asserting' stamp: ''!
assertIsClassSide
	self assertButtonSelected: 'class'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/12/2004 23:55'!
testJumpToBogusA
	self selectBogusPackage.
	model jumpTo: (OBClassNode on: BogusA).
	self assertCurrentItemIs: self bogusAName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testCreateMethodFromTemplate
	self selectBogusCategory.
	self selectBogusA.
	self select: 'letters'.
	self setText: self methodFour.
	damage add: #four ofClass: #BogusA.
	self assertAListMatches: #('a' 'b' 'four').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self name = #OBCodeBrowserTest! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/10/2004 23:46'!
testEditClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusCDefinition.
	damage add: #Definition ofClass: #BogusC.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: #BogusC.
	self assert: BogusC instVarNames = #(foo)! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:23'!
testSelectBogusAComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: BogusInfo aComment.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testSelectNumbers
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self methodTemplate.
	self assertTextIsSelected.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeAClassTemplate
	^  self deprecated: 'Use #bogusAClassTemplate'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToMethodOne
	self selectBogusPackage.
	model jumpTo: (OBMethodNode 
					on: #one 
					inClass: BogusA).
	self assertCurrentItemIs: 'one'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusBComment
	^ 'A comment for BogusB'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
altMethodOne
	^ 'one
	^ 11'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassDDefinition
	self deprecated: 'Use #bogusDDefinition'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
switchToClassSide
	self clickButtonLabeled: 'class'! !

OBBrowserTest subclass: #OBInheritanceBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
interiorNode
	^ OBMethodNode on: #isString inClass: BogusA! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 11/7/2004 21:26'!
metagraph
	^ OBBrowser metagraphAt: #MethodInheritance! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
rootNode
	^ OBCollectionNode on: {OBMethodNode 
								on: #isString 
								inClass: Object}! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/5/2004 18:03'!
setUpWith: targetNode
	[OBInheritanceBrowser openRoot: self rootNode selection: targetNode]
		on: OBBrowseRequest
		do: [:notification | 
			model := notification browser.
			morph := model morph].
	self forceLayout.! !

!OBInheritanceBrowserTest methodsFor: 'testing' stamp: 'cwp 11/28/2004 10:24'!
testInitialDisplay2
	self setUpWith: self leafNode.
	self 
		assertListAt: 1 contains: #('Object>>isString');
		assertListAt: 2 contains: #('BogusA>>isString' 'AbstractString>>isString');
		assertListAt: 3 contains: #('BogusE>>isString');
		assertCurrentItemIs: 'BogusE>>isString'! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 11/28/2004 10:22'!
setUp! !

!OBInheritanceBrowserTest methodsFor: 'testing' stamp: 'cwp 11/28/2004 10:23'!
testInitialDisplay
	self setUpWith: self interiorNode.
	self 
		assertListAt: 1 contains: #('Object>>isString');
		assertListAt: 2 contains: #('BogusA>>isString' 'AbstractString>>isString');
		assertListAt: 3 contains: #('BogusE>>isString');
		assertCurrentItemIs: 'BogusA>>isString'! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
leafNode
	^ OBMethodNode on: #isString inClass: BogusE! !

OBBrowserTest subclass: #OBReferencesBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBReferencesBrowserTest methodsFor: 'configuration' stamp: 'cwp 11/30/2004 21:07'!
node
	^ OBClassNode on: BogusC
! !

!OBReferencesBrowserTest methodsFor: 'configuration' stamp: 'cwp 11/30/2004 20:25'!
metagraph
	^ OBBrowser metagraphAt: #References! !

!OBReferencesBrowserTest methodsFor: 'bogus' stamp: 'cwp 12/1/2004 00:58'!
refersToBogusC
	^ BogusC! !

!OBReferencesBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/5/2004 18:26'!
browserClass
	^ OBListBrowser! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 12/1/2004 01:09'!
testSelectorSelection
	self select: 'OBReferencesBrowserTest>>refersToBogusC'.
	self deny: self textMorph getSelection = (9 to: 13)! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 12/1/2004 00:32'!
testClassNameSelection
	self select: 'OBReferencesBrowserTest>>node'.
	self assertSelectedTextIs: 'BogusC'! !

!OBReferencesBrowserTest methodsFor: 'constants' stamp: 'cwp 12/1/2004 01:18'!
bogusCReferences
	^ {	'OBCodeBrowserTest>>testEditClass'.
		'OBReferencesBrowserTest>>node'.
		'OBReferencesBrowserTest>>refersToBogusC' }! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 11/30/2004 20:31'!
testInitialDisplay
	self assertListAt: 1 contains: self bogusCReferences! !

OBBrowserTest subclass: #OBAccessBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBAccessBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/5/2004 20:17'!
metagraph
	^ OBBrowser metagraphAt: #Variables! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectIvar
	self select: 'firstInstanceVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesIvar')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectIVarAccessor
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self assertListAt: 3 includes: #('BogusB>>sendsAccessesIvar')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectCVar
	self clickButtonLabeled: 'class'.
	self select: 'FirstClassVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesCVar' 
								   'BogusB class>>accessesCVarAlso')! !

!OBAccessBrowserTest methodsFor: 'configuration' stamp: ''!
node
	^ OBClassNode on: BogusB! !

!OBAccessBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/5/2004 18:20'!
browserClass
	^ OBListBrowser! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectSender
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self select: 'BogusB>>sendsAccessesIvar'.
	self assertListAt: 4 contains: #('BogusB>>sendsSendsAccessesIvar')
! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testInitalDisplay
	self assertListAt: 1 contains: BogusInfo bInstVarNames! !

OBBrowserTest subclass: #OBChasingBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

OBChasingBrowserTest subclass: #OBImplementorsBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:47'!
metagraph
	^ OBBrowser metagraphAt: #Implementors! !

!OBImplementorsBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:41'!
testMessagesOf
	self clickButtonLabeled: 'chase'.
	self select: 'BogusB>>sendsSendsAccessesIvar'.
	self assertListAt: 2 contains: #('sendsAccessesIvar')! !

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 23:37'!
initialList
	^ #('BogusB>>sendsSendsAccessesIvar')! !

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 23:37'!
node
	"We don't want this method to show up in senders 
	of #sendsSendsAccesses, since other tests 
	aren't expecting it."
	
	| selector |
	selector := ('sendsSendsAccesses', 'Ivar') asSymbol.
	^ OBMethodNode on: selector inClass: BogusB! !

!OBChasingBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:03'!
testChaseDisplay
	self clickButtonLabeled: 'chase'.
	self 
		assertListAt: 1 
		contains: self initialList! !

OBChasingBrowserTest subclass: #OBSendersBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBSendersBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:15'!
testSendersOf
	self clickButtonLabeled: 'chase'.
	self select: 'BogusB>>sendsAccessesIvar'.
	self assertListAt: 2 contains: #('BogusB>>sendsSendsAccessesIvar')! !

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:59'!
initialList
	^  #('BogusB>>sendsAccessesIvar')! !

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:35'!
metagraph
	^ OBBrowser metagraphAt: #Senders! !

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:44'!
node
	"We don't want this method to show up in senders 
	of #accessesIvar, since that's what we're testing"
	
	| selector |
	selector := ('accesses', 'Ivar') asSymbol.
	^ OBMethodNode on: selector inClass: BogusB! !

!OBChasingBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2004 22:59'!
isAbstract
	^ self name = #OBChasingBrowserTest! !

!OBChasingBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:56'!
browserClass
	^ OBListBrowser! !

!OBChasingBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 22:58'!
testInitialDisplay
	self 
		assertListAt: 1 
		contains: self initialList! !

OBBrowserTest subclass: #OBVersionsBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBVersionsBrowserTest methodsFor: 'constants' stamp: ''!
twoSourcePointer
	^ 33555020! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: 'cwp 11/27/2004 21:39'!
testSourceDisplay
	self select: 'BogusA>>two cwp 3/11/2004 20:07'.
	self assertTextIs: self twoLatestVersionText! !

!OBVersionsBrowserTest methodsFor: 'emulating' stamp: ''!
sourceFiles
	^ OBSourceFilesResource current sources! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: ''!
tearDown
	(BogusA compiledMethodAt: #two) setSourcePointer: 0! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: ''!
testInitialDisplay
	self assertListAt: 1 contains: self expectedHeadings! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'cwp 11/7/2004 21:26'!
metagraph
	^ OBBrowser metagraphAt: #Versions! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: 'cwp 11/27/2004 21:43'!
expectedHeadings
	^ #('BogusA>>two cwp 3/11/2004 20:07' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:07' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:06')! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'cwp 12/5/2004 18:02'!
setUp
	(BogusA compiledMethodAt: #two) setSourcePointer: self twoSourcePointer.
	[OBVersionBrowser openOn: self node]
		on: OBBrowseRequest, OBSourceFilesRequest 
		do: [:notification |
			notification isBrowseRequest
				ifTrue: [model := notification browser.
						morph := model morph]
				ifFalse: [notification resume: self sourceFiles]].
	self forceLayout
		! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: ''!
twoLatestVersionText
	^  'two
	^ 6' asText makeSelectorBold! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: ''!
node
	^ OBMethodNode on: #two inClass: BogusA! !

!ClassOrganizer methodsFor: '*ob-standard-testing' stamp: 'cwp 9/18/2004 23:59'!
isClassOrganizer
	^ true! !

Object subclass: #OBCodeGraphInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 21:39'!
inheritance
	| method root |
	method := OBMetaNode named: 'Method'.
	root := OBMetaNode named: 'Root'.
	root
		childAt: #children put: method.
	method
		displaySelector: #fullName;
		childAt: #overrides put: method;
		addActor: OBNodeActor new.
	^ root! !

!OBCodeGraphInitializer methodsFor: 'helpers' stamp: 'cwp 12/13/2004 00:52'!
addTo: root class: classSel comment: commentSel metaclass: metaclassSel 
	| class metaclass comment methodCategory method |
	class := OBMetaNode named: 'Class'.
	comment := OBMetaNode named: 'ClassComment'.
	metaclass := OBMetaNode named: 'Metaclass'.
	methodCategory := OBMetaNode named: 'MethodCategory'.
	method := OBMetaNode named: 'Method'.
	root
		childAt: classSel
			labeled: 'instance'
			put: class;
		childAt: commentSel
			labeled: '?'
			put: comment;
		childAt: metaclassSel
			labeled: 'class'
			put: metaclass;
		addActor: (OBNodeActor onNodeClass: OBClassCategoryNode);
		addActor: OBCategoryActor new;
		filterClass: OBModalFilter.
	class
		displaySelector: #indentedName;
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new;
		addActor: OBClassActor new.
	comment 
		displaySelector: #indentedName;
		addActor: OBNodeActor new.
	metaclass
		displaySelector: #indentedName;
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new.
	methodCategory
		childAt: #methods put: method;
		addActor: OBCategoryActor new;
		addActor: (OBNodeActor onNodeClass: OBMethodCategoryNode).
	method addActor: OBNodeActor new.
	^ root! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 22:17'!
references
	| class method |
	class := OBMetaNode named: 'Class'.
	method := OBMetaNode named: 'References'.
	
	class
		childAt: #users put: method;
		addActor: OBNodeActor new.
	method
		displaySelector: #fullName;
		addActor: OBNodeActor new.
		
	^ class! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/12/2004 22:07'!
hierarchicalImage
	^self 
		imageClass: #classesHierarchically
		comment: #commentsHierarchically
		metaclass: #metaclassesHierarchically! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 21:39'!
variables
	| class method message var |
	class := OBMetaNode named: 'Class'.
	var := OBMetaNode named: 'Variable'.
	method := OBMetaNode named: 'Method'.
	message := OBMetaNode named: 'Message'.
	class
		addActor: OBNodeActor new;
		childAt: #instanceVariables labeled: 'instance' put: var;
		childAt: #classVariables labeled: 'class' put: var;
		filterClass: OBModalFilter.
	var
		childAt: #accessors put: method;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	method
		displaySelector: #fullName;
		addActor: OBNodeActor new;
		childAt: #senders put: message;
		filterClass: OBModalFilter.
	message
		displaySelector: #fullName;
		addActor: OBNodeActor new;
		childAt: #senders put: message;
		filterClass: OBModalFilter.
	
	^ class! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 23:40'!
chaseImplementors
	| send message implementor |
	send := OBMetaNode named: 'Send'.
	message := OBMetaNode named: 'Message'.
	implementor := OBMetaNode named: 'Implementor'.
	implementor
		displaySelector: #fullName;
		childAt: #messages put: message;
		childAt: #senders put: send;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	message
		childAt: #implementors put: implementor;
		childAt: #sendersOfMessage labeled: 'senders' put: send;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	send
		displaySelector: #fullName;
		childAt: #implementors put: implementor;
		childAt: #messages put: message;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	^ implementor! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 22:48'!
implementors
	| selector implementors |
	selector := OBMetaNode named: 'Selector'.
	implementors := OBMetaNode named: 'Implementors'.
	
	selector 
		childAt: #implementors labeled: 'list' put: implementors;
		childAt: #implementors labeled: 'chase' put: self chaseImplementors;
		filterClass: OBModalFilter.
	implementors 
		displaySelector: #fullName;
		addActor: OBNodeActor new.

	^ selector! !

!OBCodeGraphInitializer methodsFor: 'installing' stamp: 'cwp 12/12/2004 22:33'!
installCodeGraphs
	OBBrowser 
		metagraphAt: #Image put: self hierarchicalImage;
		metagraphAt: #Implementors put: self implementors;
		metagraphAt: #Senders put: self senders;
		metagraphAt: #References put: self references;
		metagraphAt: #Versions put: self versions;
		metagraphAt: #MethodInheritance put: self inheritance;
		metagraphAt: #Variables put: self variables! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/12/2004 22:55'!
hierarchy
	^ self 
		addTo: (OBMetaNode named: 'RootClass')
		class: #classHierarchy 
		comment: #commentHierarchy 
		metaclass: #metaclassHierarchy.
! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 23:14'!
chaseSenders
	| send message implementor |
	send := OBMetaNode named: 'Send'.
	message := OBMetaNode named: 'Message'.
	implementor := OBMetaNode named: 'Implementor'.
	send
		displaySelector: #fullName;
		childAt: #senders put: send;
		childAt: #messages put: message;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	message
		displaySelector: #fullName;
		childAt: #implementors put: implementor;
		childAt: #sendersOfMessage labeled: 'senders' put: send;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	implementor
		childAt: #senders put: send;
		childAt: #messages put: message;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	^ send! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/5/2004 20:24'!
versions
	| version |
	version := OBMetaNode named: 'Version'.
	version addActor: OBNodeActor new.
	^ (OBMetaNode named: 'Method') 
		childAt: #versions put: version.! !

!OBCodeGraphInitializer methodsFor: 'helpers' stamp: 'cwp 12/12/2004 22:52'!
imageClass: classSel comment: commentSel metaclass: metaclassSel 
	| environment classCategory |
	environment := OBMetaNode named: 'Environment'.
	classCategory := OBMetaNode named: 'ClassCategory'.
	environment childAt: #categories put: classCategory.
	self addTo: classCategory class: classSel comment: commentSel metaclass: metaclassSel.
	^environment! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/8/2004 22:46'!
senders
	| selector senders |
	selector := OBMetaNode named: 'Selector'.
	senders := OBMetaNode named: 'Senders'.
	
	selector 
		childAt: #senders labeled: 'list' put: senders;
		childAt: #senders labeled: 'chase' put: self chaseSenders;
		filterClass: OBModalFilter.
	senders 
		displaySelector: #fullName;
		addActor: OBNodeActor new.

	^ selector! !

!OBCodeGraphInitializer class methodsFor: 'class initialization' stamp: 'cwp 10/26/2004 00:57'!
initialize
	self new installCodeGraphs
	! !

!OBCodeGraphInitializer methodsFor: 'browsers' stamp: 'cwp 12/12/2004 22:09'!
alphabeticalImage
	^ self
		imageClass: #classes
		comment: #comments
		metaclass: #metaclasses
! !

Object subclass: #OBMethodVersion
	instanceVariableNames: 'sources pointer classRef className category stamp prior selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:42'!
pointer
	^ pointer! !

!OBMethodVersion class methodsFor: 'instance creation' stamp: ''!
fromSources: sources andPointer: pointer
	^ self new setSources: sources pointer: pointer! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
theClass
	^ classRef theClass! !

!OBMethodVersion methodsFor: 'initializing' stamp: ''!
parseSource
	| file position chunk |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	position := sources filePositionFromSourcePointer: pointer.
	position > file size ifTrue: [self error: 'Invalid source pointer'].
	
	file position: (0 max: position-150).  	"Skip back to before the preamble"
		[file position < (position-1)]  	"then pick it up from the front"
			whileTrue: [chunk := file nextChunk].
	
	self parseChunk: chunk.! !

!OBMethodVersion methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:51'!
latest
	^ self class 
			fromSources: sources 
			andPointer: (classRef theClass compiledMethodAt: selector) sourcePointer! !

!OBMethodVersion methodsFor: 'initializing' stamp: ''!
previous
	^ prior ifNotNil: [self class fromSources: sources andPointer: prior]! !

!OBMethodVersion methodsFor: 'initializing' stamp: ''!
setSelector
	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ selector := Parser new parseSelector: file nextChunk.! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
theClassName
	^ classRef name! !

!OBMethodVersion class methodsFor: 'scanning' stamp: ''!
scan: sources from: pointer 
	| versions current |
	
	versions := OrderedCollection new.
	current := OBMethodVersion fromSources: sources andPointer: pointer.
	[current notNil]
		whileTrue: [versions add: current.
					current := current previous].
	^ versions! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
source
	| file |
	file := sources at: (sources fileIndexFromSourcePointer: pointer).
	file position: (sources filePositionFromSourcePointer: pointer).
	^ file nextChunk asText makeSelectorBold! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
category
	^ category! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
stamp
	^ stamp! !

!OBMethodVersion methodsFor: 'comparing' stamp: 'cwp 10/17/2004 23:45'!
= other
	^ self species = other species and: [self pointer = other pointer]! !

!OBMethodVersion methodsFor: 'comparing' stamp: 'cwp 10/17/2004 23:45'!
hash
	^ pointer hash! !

!OBMethodVersion methodsFor: 'initializing' stamp: 'cwp 11/6/2004 23:14'!
parseChunk: aString
	| tokens |
	tokens := Scanner new scanTokens: aString.
	classRef := OBClassReference named: tokens first.
	tokens second = #class
		ifTrue: [classRef beMeta.
				category := tokens fourth.
				stamp := tokens sixth]
		ifFalse: [category := tokens third.
				tokens size > 3 ifTrue: [stamp := tokens fifth]].
	tokens size > 6 ifTrue: [prior := tokens last].! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
classSymbol
	^ classRef name! !

!OBMethodVersion methodsFor: 'accessing' stamp: ''!
selector
	^ selector ifNil: [self setSelector]! !

!OBMethodVersion class methodsFor: 'scanning' stamp: ''!
versionsOfMethod: methodReference 
	| class selector |
	class := methodReference actualClass.
	selector := methodReference methodSymbol.
	^ self scan: SourceFiles from: (class compiledMethodAt: selector) sourcePointer! !

!OBMethodVersion methodsFor: 'compiling' stamp: ''!
fileIn
	(self theClass) ifNotNilDo: [:class | class
						 				compile: self source 
										classified: self category 
										withStamp: self stamp 
										notifying: nil]
						
						! !

!OBMethodVersion methodsFor: 'initializing' stamp: ''!
setSources: aSourceFileArray pointer: aSourcePointer
	sources := aSourceFileArray.
	pointer := aSourcePointer.
	self parseSource.! !

Object subclass: #OBSystemBrowserAdaptor
	instanceVariableNames: 'class selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBSystemBrowserAdaptor class methodsFor: 'registry protocol' stamp: 'cwp 12/5/2004 21:59'!
openBrowser
	OBSystemBrowser open! !

!OBSystemBrowserAdaptor class methodsFor: 'initializing' stamp: 'cwp 12/5/2004 22:03'!
unregister
	SystemBrowser unregister: self! !

!OBSystemBrowserAdaptor methodsFor: 'registry protocol' stamp: 'cwp 12/5/2004 21:50'!
labelString
	^ 'System Browser'! !

!OBSystemBrowserAdaptor methodsFor: 'registry protocol' stamp: 'cwp 12/5/2004 21:49'!
setClass: aClass selector: aSelector 
	class _ aClass.
	selector _ aSelector! !

!OBSystemBrowserAdaptor methodsFor: 'registry protocol' stamp: 'cwp 12/5/2004 21:49'!
openEditString: anUndefinedObject 
	^ self! !

!OBSystemBrowserAdaptor methodsFor: 'accessing' stamp: 'cwp 12/5/2004 21:55'!
selector
	^ selector! !

!OBSystemBrowserAdaptor class methodsFor: 'registry protocol' stamp: 'cwp 12/5/2004 21:56'!
openBrowserView: adaptor label: ignored 
	^ OBSystemBrowser 
		openOnClass: adaptor targetClass 
		selector: adaptor selector! !

!OBSystemBrowserAdaptor class methodsFor: 'initializing' stamp: 'cwp 12/5/2004 22:01'!
initialize
	self register! !

!OBSystemBrowserAdaptor class methodsFor: 'initializing' stamp: 'cwp 12/5/2004 21:45'!
register
	SystemBrowser register: self! !

!OBSystemBrowserAdaptor methodsFor: 'accessing' stamp: 'cwp 12/5/2004 21:55'!
targetClass
	^ class! !

Object subclass: #OBClassReference
	instanceVariableNames: 'name isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBClassReference methodsFor: 'comparing' stamp: ''!
hash
	^ isMeta
		ifTrue: [name hash bitInvert]
		ifFalse: [name hash]! !

!OBClassReference methodsFor: 'accessing' stamp: ''!
theClass
	| theClass |
	theClass := self theNonMetaClass ifNil: [^ nil].
	^ isMeta
		ifFalse: [theClass]
		ifTrue: [theClass class]! !

!OBClassReference methodsFor: 'testing' stamp: ''!
beNonMeta
	isMeta := false! !

!OBClassReference methodsFor: 'comparing' stamp: ''!
= other
	^ (other isKindOf: self class) 
		and: [name = other theNonMetaName] 
		and: [isMeta = other isMeta]! !

!OBClassReference methodsFor: 'initializing' stamp: ''!
setName: aSymbol
	name := (aSymbol copyUpTo: $ ) asSymbol.
	isMeta := aSymbol endsWith: ' class'.! !

!OBClassReference methodsFor: 'accessing' stamp: ''!
theNonMetaName
	^ name! !

!OBClassReference class methodsFor: 'instance creation' stamp: ''!
metaNamed: aSymbol
	^ (self named: aSymbol) beMeta! !

!OBClassReference methodsFor: 'testing' stamp: ''!
beMeta
	isMeta := true! !

!OBClassReference methodsFor: 'testing' stamp: ''!
isMeta
	^ isMeta! !

!OBClassReference methodsFor: 'converting' stamp: ''!
referenceToMethod: aSelector
	| ref |
	ref := MethodReference new.
	ref setClassSymbol: name classIsMeta: isMeta  methodSymbol: aSelector stringVersion: ''.
	^ ref! !

!OBClassReference class methodsFor: 'instance creation' stamp: ''!
to: aClass
	^ self named: aClass name! !

!OBClassReference class methodsFor: 'instance creation' stamp: ''!
named: aSymbol
	^ self new setName: aSymbol! !

!OBClassReference methodsFor: 'accessing' stamp: ''!
theNonMetaClass
	^ Smalltalk at: name ifAbsent: [].! !

!OBClassReference methodsFor: 'comparing' stamp: ''!
<= other
	^ self name <= other name! !

!OBClassReference methodsFor: 'accessing' stamp: ''!
name
	^ isMeta
		ifTrue: [name, ' class']
		ifFalse: [name]! !

!OBClassReference methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: 'OBClassReference'.
	aStream nextPut: $<.
	aStream nextPutAll: name.
	isMeta ifTrue: [aStream nextPutAll: ' class'].
	aStream nextPut: $>.! !

!OBClassReference methodsFor: 'accessing' stamp: ''!
theNonMetaName: aSymbol
	name := aSymbol! !

!OBDefinitionPanel methodsFor: '*ob-standard-cmds' stamp: 'cwp 12/5/2004 17:15'!
sendersOfIt: aSelector 
	OBListBrowser 
		browse: #Senders
		root: (OBSelectorNode on: aSelector)
		title: 'Senders of'.
	^true! !

!OBDefinitionPanel methodsFor: '*ob-standard-cmds' stamp: 'cwp 12/5/2004 17:15'!
implementorsOfIt: aSelector 
	OBListBrowser 
		browse: #Implementors
		root: (OBSelectorNode on: aSelector)
		title: 'Implementors of'.
	^true! !

!OBDefinitionPanel methodsFor: '*ob-standard-cmds' stamp: 'cwp 12/5/2004 18:21'!
browseIt: aSymbol
	| entry |
	entry := self selectedClass environment at: aSymbol ifAbsent: [nil].
	entry ifNil: [^ self implementorsOfIt: aSymbol].
	(entry isKindOf: Class) ifFalse: [entry _ entry class].
	OBSystemBrowser openOnClass: entry.
	^ true
	! !

!OBDefinitionPanel methodsFor: '*ob-standard-cmds' stamp: 'cwp 12/5/2004 17:15'!
referencesToIt: aClassName 
	| class |
	class := self selectedClass environment at: aClassName ifAbsent: [^false].
	class isBehavior ifFalse: [^false].
	OBListBrowser 
		browse: #References
		root: (OBClassNode on: class)
		title: 'References to'.
	^true! !

OBOpenTest subclass: #OBStandardOpenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:44'!
testSystemOpen
	self open: [OBSystemBrowser open].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode = nil! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:44'!
testSystemOpenOnClassSelector
	self open: [OBSystemBrowser openOnClass: BogusA selector: #one].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode name = #one! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 18:31'!
testSystemOpenOnClass
	self open: [OBSystemBrowser openOnClass: BogusA].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode name = #BogusA! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 18:31'!
testListBrowseRootTitle
	self open: [OBListBrowser 
				browse: #Senders 
				root: (OBMethodNode on: #one inClass: BogusA)
				title: 'Senders of'].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 2.
	self assert: browser currentNode isNil.
	self assert: browser defaultLabel = 'Senders of #one'! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:52'!
testVersionsOpenOn
	| root |
	root _ OBMethodNode on: #testVersionsOpenOn inClass: self class.
	self open: [OBVersionBrowser openOn: root].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 1.
	self assert: browser currentNode isNil.
	self assert: browser root = root! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 18:30'!
testListBrowseRoot
	self open: [OBListBrowser browse: #Senders root: (OBMethodNode on: #one inClass: BogusA)].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 2.
	self assert: browser currentNode isNil! !

TestResource subclass: #OBBrowserResource
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBBrowserResource methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!OBBrowserResource methodsFor: 'running' stamp: 'cwp 12/5/2004 18:13'!
setUp
	model := OBBrowser metaNode: self metagraph node: self node.
	model addPanel: (OBDefinitionPanel inBrowser: model).
	morph := model morph.! !

OBBrowserResource subclass: #OBImageBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBImageBrowserResource methodsFor: 'running' stamp: ''!
node
	^ OBEnvironmentNode forImage! !

!OBImageBrowserResource methodsFor: 'running' stamp: 'cwp 12/12/2004 22:09'!
metagraph
	^ OBCodeGraphInitializer new alphabeticalImage! !

!OBBrowserResource methodsFor: 'accessing' stamp: ''!
morph
	^ morph! !

TestResource subclass: #OBSourceFilesResource
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
changesString
	^ '!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05'' prior: 16777764!!
one
	^ 4!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777864!!
two
	^ 4!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554520!!
one
	^ 5!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554620!!
two
	^ 5!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554720!!
one
	^ 6!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554820!!
two
	^ 6!! !!
!!BogusA class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777462!!
three
	^ 2!! !!'! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
sourceString
	^ '!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05''!!
one
	^ 1!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
two
	^ 1!! !!
!!BogusA class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
three
	^ 1!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777288!!
one
	^ 2!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777372!!
two
	^ 2!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777600!!
one
	^ 3!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777664!!
two
	^ 3!! !!'! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
setUp
	sources := StandardSourceFileArray new: 2.
	sources at: 1 put: self sourceStream.
	sources at: 2 put: self changesStream.! !

!OBSourceFilesResource methodsFor: 'accessing' stamp: ''!
sources
	^ sources! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
changesStream
	^ ReadStream on: self changesString! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
sourceStream
	^ ReadStream on: self sourceString! !

!Class methodsFor: '*ob-standard-converting' stamp: ''!
asNode
	^ OBClassNode on: self! !

OBDefinition subclass: #OBMethodDefinition
	instanceVariableNames: 'theClass category source selection callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBMethodDefinition methodsFor: 'confirming' stamp: ''!
selectorAlreadyDefined: aSelector
	^ self theClass selectors includes: aSelector! !

!OBMethodDefinition methodsFor: 'confirming' stamp: 'cwp 10/17/2004 22:42'!
confirmMethod: aText
	| sel |
	sel _ Parser new parseSelector: aText.
	^ (self theClass isMeta 
			and: [(self selectorAlreadyDefined: sel) not] 
			and: [Metaclass isScarySelector: sel])
				ifTrue: [self confirmScarySelector: sel]
				ifFalse: [^ true]! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: ''!
selectedClass
	^ self theClass! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
selection: anInterval source: aText inCategory: aCategory inClass: aClass
	^ self new
		setClass: aClass
		category: aCategory
		source: aText
		selection: anInterval! !

!OBMethodDefinition methodsFor: 'accessing' stamp: ''!
theClass
	^ theClass! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'cwp 10/17/2004 23:33'!
nodeFor: aSelector
	^ callback value: aSelector! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:36'!
callback: aBlockContext 
	callback _ aBlockContext! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
selection: anInterval source: aText inClass: aClass
	^ self 
		selection: anInterval
		source: aText
		inCategory: nil
		inClass: aClass	! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: ''!
selection
	^ selection ifNil: [1 to: (source ifNil: [self text size] ifNotNil: [0])]! !

!OBMethodDefinition methodsFor: 'compiling' stamp: ''!
compileMethod: aText notifying: aController
	^ (self confirmMethod: aText)
		ifTrue: [self theClass 
					compile: aText 
					classified: self category 
					notifying: aController]
		ifFalse: [nil]! !

!OBMethodDefinition methodsFor: 'confirming' stamp: ''!
confirmScarySelector: aSelector
	| prompt |
	prompt := aSelector, ' is used in the existing class system.
Overriding it could cause serious problems.
Is this really what you want to do?'.

	^ OBConfirmationRequest
		prompt: prompt
		confirm: 'Override'! !

!OBMethodDefinition methodsFor: 'accessing' stamp: ''!
category
	^ category ifNil: [category := self theClass whichCategoryIncludesSelector: self selector]! !

!OBMethodDefinition methodsFor: 'accessing' stamp: ''!
selector
	^ source ifNotNil: [Parser new parseSelector: source]! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:03'!
source: aText inClass: aClass
	^ self 
		selection: nil
		source: aText
		inCategory: nil
		inClass: aClass! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 12/2/2004 23:29'!
accept: aText notifying: aController
	| newSelector |
	newSelector := self compileMethod: aText notifying: aController.
	newSelector ifNil: [^ false].
	(self nodeFor: newSelector) signalSelection.
	^ true! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 11/29/2004 21:21'!
text
	^ source 
		ifNotNil: [source asText makeSelectorBold]
		ifNil: [self theClass sourceCodeTemplate]! !

!OBMethodDefinition methodsFor: 'initializing' stamp: 'cwp 10/17/2004 23:33'!
setClass: aClass category: aString source: aText selection: anInterval
	theClass := aClass.
	category := aString.
	source := aText.
	selection := anInterval.
	callback := [:sel | OBMethodNode on: sel inClass: theClass]! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
inCategory: aString inClass: aClass
	^ self 
		selection: nil
		source: nil
		inCategory: aString
		inClass: aClass! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'cwp 10/17/2004 23:16'!
redefineSource: aText selector: newSelector
	newSelector = self selector 
		ifTrue: [source := aText]
		ifFalse: [(self methodNodeFor: newSelector) signalSelection].
! !

OBDefinition subclass: #OBOrganizationDefinition
	instanceVariableNames: 'organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBOrganizationDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2004 21:20'!
on: anOrganizer
	^ self new organizer: anOrganizer! !

!OBOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 9/23/2004 21:59'!
text: aText
	organizer changeFromString: aText asString! !

!OBOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2004 21:18'!
text
	^ organizer asString! !

!OBOrganizationDefinition methodsFor: 'as yet unclassified' stamp: 'cwp 9/22/2004 21:21'!
organizer: anOrganizer
	organizer _ anOrganizer! !

OBDefinition subclass: #OBClassDefinition
	instanceVariableNames: 'environment template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Utilities'!

!OBClassDefinition methodsFor: 'class definition' stamp: ''!
evaluatorForDefinition: definition
	| tokens |
	tokens := Scanner new scanTokens: definition.
	^ (environment at: tokens first ifAbsent: [nil]) subclassDefinerClass! !

!OBClassDefinition methodsFor: 'class definition' stamp: ''!
signalSelectionOf: aClass
	((aClass isMeta
		ifTrue: [OBMetaclassNode] 
		ifFalse: [OBClassNode]) 
			on: aClass) signalSelection! !

!OBClassDefinition methodsFor: 'callbacks' stamp: ''!
text
	^ template! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
confirmRedefinition: definition
	| newName prompt |
	newName := self nameOfClassDefinedBy: definition.
	prompt := (newName, ' is an existing class in this system.
Redefining it might cause serious problems.
Is this really what you want to do?') asText.
	^ OBConfirmationRequest
		prompt: prompt
		confirm: 'Redefine'! !

!OBClassDefinition methodsFor: 'callbacks' stamp: ''!
selection
	^ 1 to: 0! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
confirmDefinition: definition
	"Check to make sure the user isn't accidentally over-writing an existing class."
	
	(((self isRedefinition: definition) not) and: [self definedClassExists: definition])
		ifTrue: [^ self confirmRedefinition: definition]
		ifFalse: [^ true]! !

!OBClassDefinition methodsFor: 'callbacks' stamp: ''!
accept: aText notifying: aController
	^ self defineClass: aText notifying: aController! !

!OBClassDefinition methodsFor: 'class definition' stamp: ''!
defineClass: definition notifying: aController
	| evaluator newClass |
	(self confirmDefinition: definition) ifFalse: [^ false].
	evaluator := self evaluatorForDefinition: definition.
	newClass := evaluator
				evaluate: definition
				notifying: aController
				logged: true.
	newClass ifNil: [^ false].
	self signalSelectionOf: newClass.
	^ true
! !

!OBClassDefinition methodsFor: 'initializing' stamp: ''!
setEnvironment: anEnvironment template: aText
	environment := anEnvironment.
	template := aText.! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'cwp 10/18/2004 00:13'!
selectedClass
	^ environment at: (self nameOfClassDefinedBy: template) ifAbsent: [nil]! !

!OBClassDefinition class methodsFor: 'instance creation' stamp: ''!
environment: anEnvironment template: aString 
	^ self new setEnvironment: anEnvironment template: aString! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
nameOfClassDefinedBy: definition
	^ (Scanner new scanTokens: definition) third! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
isRedefinition: aDefinition
	^ (self nameOfClassDefinedBy: aDefinition) = (self nameOfClassDefinedBy: template)! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
definedClassExists: definition
	^ environment hasClassNamed: (self nameOfClassDefinedBy: definition)! !

TestCase subclass: #OBSystemBrowserAdaptorTest
	instanceVariableNames: 'oldDefault browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 12/5/2004 21:58'!
openWith: aBlock
	aBlock
		on: OBBrowseRequest
		do: [:n | browser _ n browser].
	self deny: browser isNil.
! !

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 12/5/2004 21:43'!
tearDown
	SystemBrowser default: oldDefault! !

!OBSystemBrowserAdaptorTest methodsFor: 'testing' stamp: 'cwp 12/5/2004 21:58'!
testFullOnClassSelector
	self openWith: [Browser fullOnClass: BogusA selector: #one].
	self assert: browser currentNode theClass = BogusA.
	self assert: browser currentNode selector = #one! !

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 12/5/2004 21:48'!
setUp
	oldDefault _ SystemBrowser defaultOrNil.
	SystemBrowser default: OBSystemBrowserAdaptor! !

!OBSystemBrowserAdaptorTest methodsFor: 'testing' stamp: 'cwp 12/5/2004 21:59'!
testDefaultOpenBrowser
	self openWith: [SystemBrowser defaultOpenBrowser].
	self assert: browser currentNode isNil! !

TestCase subclass: #OBAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassIdentity
	self 
		assert: (OBClassNode on: BogusA)
		isAncestorOf: (OBClassNode on: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 21:46'!
testClassInOtherCategory
	| cat |
	cat := OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk.
	self deny: cat isAncestorOf: (OBClassNode on: BogusF)
	
! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 12:54'!
testMethodInClassCat
	self 
		assert: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)
! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassCategoryIdentity
	self 
		assert: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk) 
		isAncestorOf: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk).
! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 21:48'!
testMethodOverride
	self 
		assert: (OBMethodNode on: #isString inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusE).
	! !

!OBAncestryTest methodsFor: 'asserting' stamp: ''!
assert: ancestor isAncestorOf: descendant
	self assert: (ancestor isAncestorOf: descendant)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassOther
	self 
		deny: (OBClassNode on: BogusB)
		isAncestorOf: (OBClassNode on: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassCategoryOther
	self 
		deny: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBClassCategoryNode on: 'Bogus-Formats' inEnvironment: Smalltalk)
	! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 21:49'!
testMethodSiblings
	self 
		deny: (OBMethodNode on: #isString inClass: AbstractString)
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusA).
	! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodInOtherClass
	self 
		deny: (OBClassNode on: BogusA)
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusE).
	! !

!OBAncestryTest methodsFor: 'asserting' stamp: ''!
deny: ancestor isAncestorOf: descendant
	self deny: (ancestor isAncestorOf: descendant)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodInMethodCat
	self 
		assert: (OBMethodCategoryNode on: #letters inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodCatIdentity
	self 
		assert: (OBMethodCategoryNode on: #letters inClass: BogusA)
		isAncestorOf: (OBMethodCategoryNode on: #letters inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodInClass
	self assert: (OBClassNode on: BogusA) isAncestorOf: (OBMethodNode on: #a inClass: BogusA).
! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 12:55'!
testClassMethodInClassCat
	self 
		assert: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA class)
! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodIdentity
	self 
		assert: (OBMethodNode on: #a inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 21:46'!
testClassInClassCategory
	| cat |
	cat := OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk.
	self assert: cat isAncestorOf: (OBClassNode on: BogusA).
	
! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodCatOther
	self 
		deny: (OBMethodCategoryNode on: #numbers inClass: BogusA)
		isAncestorOf: (OBMethodCategoryNode on: #letters inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodInMetaclass
	self deny: (OBClassNode on: BogusA) isAncestorOf: (OBMethodNode on: #a inClass: BogusA class)
	! !

TestCase subclass: #OBCodeSanityCheckTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: ''!
codeContext
	^ OBImageContext new! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: ''!
testClassDefinition
	node := OBClassNode on: BogusA.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: ''!
bogusCDefinition
	^ 'Object subclass: #BogusC
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: ''!
selectionInterval
	^ 1 to: 0! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: ''!
testClassRedefinition
	node := OBClassNode on: BogusA.
	self 
		shouldnt: [node accept: self bogusARedefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: ''!
bogusARedefinition
	^ BogusA definition! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: ''!
text
	^ node text asText! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: ''!
testClassCreation
	node := OBClassCategoryNode on: BogusInfo baseCategory inEnvironment: Smalltalk.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

TestCase subclass: #OBMethodVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromPointer
	| changes sourcePointer sources |
	sources :=  self fakeSourceFileArray.
	sourcePointer := sources sourcePointerFromFileIndex: 2 andPosition: 488.
	changes := OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 6.
	changes do: [:ea | 
					self assert: ea theClassName = #BogusA.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

!OBMethodVersionTest methodsFor: 'constants' stamp: ''!
methodReference
	| ref |
	ref := MethodReference new.
	ref setStandardClass: self class methodSymbol: #testScanFromMethodRef.
	^ ref! !

!OBMethodVersionTest methodsFor: 'constants' stamp: ''!
fakeSourceFileArray
	^ OBSourceFilesResource current sources! !

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromMethodRef
	| changes |
	changes := OBMethodVersion versionsOfMethod: self methodReference.
	self deny: changes isEmpty! !

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromPointerToClassMethod
	| changes sourcePointer sources |
	sources :=  self fakeSourceFileArray.
	sourcePointer := sources sourcePointerFromFileIndex: 2 andPosition: 694.
	changes := OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 2.
	changes do: [:ea | 
					self assert: ea theClassName = #'BogusA class'.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

TestCase subclass: #OBClassHierarchyTest
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:11'!
testAB
	self assert: (classes indexOf: self bogusA) < (classes indexOf: self bogusB)! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:12'!
nodeForClassNamed: aSymbol
	^ classes detect: [:ea | ea theClassName = aSymbol]! !

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:33'!
testAE
	self assert: (classes indexOf: self bogusA) < (classes indexOf: self bogusE)! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:13'!
bogusB
	^ self nodeForClassNamed: #BogusB! !

!OBClassHierarchyTest methodsFor: 'running' stamp: 'cwp 12/12/2004 22:24'!
setUp
	| metacat cat |
	metacat := OBMetaNode new childAt: #classesHierarchically
				put: (OBMetaNode new displaySelector: #name).
	cat := OBClassCategoryNode on: BogusInfo baseCategory
				inEnvironment: BogusInfo environment.
	classes := metacat nodesForParent: cat! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:13'!
bogusA
	^ self nodeForClassNamed: #BogusA! !

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:29'!
testEB
	self assert: (classes indexOf: self bogusE) < (classes indexOf: self bogusB)! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:29'!
bogusE
	^ self nodeForClassNamed: #BogusE! !

TestCase subclass: #OBCodeBrowserUiTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCodeBrowserUiTest methodsFor: 'tests' stamp: 'cwp 12/6/2004 22:20'!
testWindowMenu
	| menu |
	menu _ MenuMorph new.
	browser addModelItemsToWindowMenu: menu.
	self deny: (menu itemWithWording: 'Register this Browser as default') isNil.
	self deny: (menu itemWithWording: 'Choose new default browser') isNil
		! !

!OBCodeBrowserUiTest methodsFor: 'running' stamp: 'cwp 12/6/2004 22:11'!
setUp
	browser _ OBSystemBrowser new.
	browser addDependent: self.
	! !

!OBCodeBrowserUiTest methodsFor: 'running' stamp: 'cwp 12/6/2004 22:11'!
tearDown
	browser removeDependent: self! !

OBBrowser subclass: #OBCodeBrowser
	instanceVariableNames: 'hasChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
unregister
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
register
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

OBCodeBrowser subclass: #OBSystemBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBSystemBrowser class methodsFor: 'opening' stamp: 'cwp 12/5/2004 18:32'!
openOnClass: aClass
	^ (self onClass: aClass) open! !

!OBSystemBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/5/2004 18:32'!
onClass: aClass
	^ self selection: (OBClassNode on: aClass)! !

!OBSystemBrowser methodsFor: 'morphic' stamp: 'avi 11/29/2004 21:52'!
defaultBackgroundColor
	^ Color lightGreen

! !

!OBSystemBrowser class methodsFor: 'options' stamp: 'cwp 12/12/2004 22:35'!
showClassesHierarchically
	OBBrowser 
		metagraphAt: #Image 
		put: OBCodeGraphInitializer new hierarchicalImage ! !

!OBSystemBrowser class methodsFor: 'configuration' stamp: 'cwp 12/6/2004 22:02'!
defaultMetagraph
	^ #Image! !

!OBSystemBrowser class methodsFor: 'initializing' stamp: ''!
registerInOpenMenu
	TheWorldMenu registerOpenCommand: {'Image Browser'. {self. #open}}.
! !

!OBSystemBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/5/2004 17:38'!
onClass: aClass selector: aSelector
	^ self selection: (OBMethodNode on: aSelector inClass: aClass)! !

!OBSystemBrowser class methodsFor: 'configuration' stamp: ''!
title
	^ 'System Browser'! !

!OBSystemBrowser class methodsFor: 'initializing' stamp: ''!
initialize
	self registerInOpenMenu! !

!OBSystemBrowser class methodsFor: 'configuration' stamp: 'cwp 12/6/2004 22:02'!
defaultRootNode
	^ OBEnvironmentNode forImage! !

!OBSystemBrowser class methodsFor: 'options' stamp: 'cwp 12/12/2004 22:34'!
showClassesAlphabetically
	OBBrowser 
		metagraphAt: #Image 
		put: OBCodeGraphInitializer new alphabeticalImage ! !

!OBSystemBrowser class methodsFor: 'opening' stamp: 'cwp 12/5/2004 17:38'!
openOnClass: aClass selector: aSelector
	^ (self onClass: aClass selector: aSelector) open! !

OBCodeBrowser subclass: #OBInheritanceBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBInheritanceBrowser class methodsFor: 'configuration' stamp: ''!
title
	^ 'Inheritance'! !

!OBInheritanceBrowser methodsFor: 'morphic' stamp: 'avi 11/29/2004 21:52'!
defaultBackgroundColor
	^ Color lightGreen! !

!OBInheritanceBrowser class methodsFor: 'configuration' stamp: 'cwp 12/6/2004 22:07'!
defaultMetagraph
	^ #MethodInheritance! !

!OBInheritanceBrowser class methodsFor: 'configuration' stamp: 'cwp 11/25/2004 22:05'!
titleForRoot: aCollectionNode
	^ 'Inheritance of ', aCollectionNode children first selector printString! !

OBCodeBrowser subclass: #OBVersionBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBVersionBrowser class methodsFor: 'configuration' stamp: 'cwp 11/27/2004 22:34'!
optionalButtons
	^ #('browse' 'revert')! !

!OBVersionBrowser class methodsFor: 'configuration' stamp: 'cwp 11/27/2004 22:32'!
maxPanes
	^ 1! !

!OBVersionBrowser methodsFor: 'accessing' stamp: 'cwp 11/27/2004 22:28'!
defaultLabel
	^ 'Versions of ', self root name printString! !

!OBVersionBrowser class methodsFor: 'opening' stamp: 'cwp 12/5/2004 15:42'!
openOn: aMethodVersionNode
	^ (self root: aMethodVersionNode) open! !

!OBVersionBrowser methodsFor: 'morphic' stamp: 'avi 11/29/2004 21:52'!
defaultBackgroundColor
	^ Color lightMagenta! !

!OBVersionBrowser class methodsFor: 'configuration' stamp: 'cwp 12/6/2004 22:07'!
defaultMetagraph
	^ #Versions! !

!OBVersionBrowser class methodsFor: 'configuration' stamp: 'cwp 11/27/2004 22:32'!
minPanes
	^ 1! !

!OBCodeBrowser class methodsFor: 'configuration' stamp: ''!
optionalButtons
	^ #('browse' 'variables' 'senders' 'implementors' 'inheritance' 'versions')! !

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
wantsStepsIn: aSystemWindow
	^ true! !

!OBCodeBrowser methodsFor: 'updating' stamp: 'cwp 9/23/2004 23:14'!
stepAt: milliseconds in: aSystemWindow
	hasChanges ifTrue: [self refresh].
	hasChanges := false! !

OBCodeBrowser subclass: #OBListBrowser
	instanceVariableNames: 'labelPrefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBListBrowser methodsFor: 'accessing' stamp: 'cwp 11/25/2004 22:18'!
labelPrefix
	^ labelPrefix ifNil: [labelPrefix _ self root metaNode edges first label capitalized, ' of']! !

!OBListBrowser methodsFor: 'morphic' stamp: 'avi 11/29/2004 21:58'!
defaultBackgroundColor
	^ Color lightBlue! !

!OBListBrowser methodsFor: 'accessing' stamp: 'cwp 10/17/2004 20:54'!
labelPrefix: aString
	labelPrefix _ aString! !

!OBListBrowser class methodsFor: 'opening' stamp: 'cwp 12/5/2004 17:17'!
browse: metaGraphName root: aNode title: aString 
	(self graph: metaGraphName root: aNode selection: nil)
		labelPrefix: aString;
		open
	! !

!OBListBrowser class methodsFor: 'configuration' stamp: 'cwp 12/5/2004 17:54'!
minPanes
	^ 1! !

!OBListBrowser methodsFor: 'accessing' stamp: 'cwp 11/25/2004 22:21'!
defaultLabel
	^ self labelPrefix, ' ', self root name printString! !

!OBListBrowser class methodsFor: 'opening' stamp: 'cwp 12/5/2004 17:18'!
browse: metaGraphName root: aNode
	(self graph: metaGraphName root: aNode selection: nil)
		open
	! !

!OBListBrowser class methodsFor: 'configuration' stamp: 'cwp 12/5/2004 17:54'!
maxPanes
	^ 2! !

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
event: anEvent
	hasChanges := true! !

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
initialExtent
	hasChanges := false.
	self register.
	^ super initialExtent! !

!OBCodeBrowser methodsFor: 'updating' stamp: ''!
windowIsClosing
	self unregister! !

OBCodeBrowser subclass: #OBHierarchyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Browsers'!

!OBHierarchyBrowser class methodsFor: 'configuration' stamp: 'cwp 12/13/2004 00:37'!
paneCount
	^ 3! !

!OBHierarchyBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2004 00:40'!
defaultBackgroundColor
	^ Color lightGreen! !

!OBHierarchyBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2004 01:00'!
defaultLabel
	^ self root name, ' Hierarchy'! !

!OBHierarchyBrowser class methodsFor: 'configuration' stamp: 'cwp 12/13/2004 01:00'!
titleForRoot: aNode
	^ aNode name, ' Hierarchy'! !

!OBCodeBrowser methodsFor: 'morphic' stamp: 'cwp 12/6/2004 22:22'!
addModelItemsToWindowMenu: aMenu
	SystemBrowser addRegistryMenuItemsTo: aMenu inAccountOf: self.! !

OBNode subclass: #OBCodeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

OBCodeNode subclass: #OBClassAwareNode
	instanceVariableNames: 'theClass superior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theClass
	^ theClass! !

!OBClassAwareNode methodsFor: 'nodes' stamp: ''!
classNode
	^ OBClassNode on: self theClass! !

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theNonMetaClassName
	^ self theNonMetaClass name! !

OBClassAwareNode subclass: #OBMethodNode
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodNode methodsFor: 'private' stamp: ''!
sendersOf: aSelector
	^ (SystemNavigation default allCallsOn: aSelector) asSortedArray
			collect: [:ref | OBMessageNode on: aSelector inMethodReference: ref]! !

!OBMethodNode methodsFor: 'actions' stamp: ''!
selectMessage
	| messages sel |
	messages := self messageSelectors copyWithFirst: selector.
	sel := (OBChoiceRequest labels: messages).
	^ sel ifNotNil: [OBMessageNode on: sel inMethodNode: self]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 19:35'!
chaseSenders
	^ self openChasingBrowser: #ChaseSenders title: 'Senders of'! !

!OBMethodNode methodsFor: 'nodes' stamp: ''!
messageNode
	^ OBMessageNode fromMethodNode: self! !

!OBMethodNode methodsFor: 'accessing' stamp: ''!
sourceFiles
	^ OBSourceFilesRequest signal! !

!OBMethodNode methodsFor: 'navigating' stamp: ''!
implementors
	^ self implementorsOf: selector! !

!OBMethodNode methodsFor: 'drag and drop' stamp: ''!
dropOnMethodCategory: aNode

	"We don't support dropping on another class yet."
	aNode theClass = self theClass ifFalse: [^ false].
	
	self theClass organization classify: self selector under: aNode name.
	OBListChanged signal.
	
	^ true! !

OBMethodNode subclass: #OBMessageNode
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMessageNode class methodsFor: 'instance creation' stamp: 'cwp 12/8/2004 23:46'!
on: aSelector inMethodReference: ref
	^ self 
		on: aSelector 
		inMethod: ref methodSymbol
		inClass: ref actualClass! !

!OBMessageNode methodsFor: 'initializing' stamp: ''!
setMessage: aSelector selector: aSelector2 class: aClass
	message := aSelector.
	selector := aSelector2.
	self theClass: aClass! !

!OBMessageNode class methodsFor: 'instance creation' stamp: ''!
on: aSelector inMethod: aSelector2 inClass: classRef
	^ self new setMessage: aSelector selector: aSelector2 class: classRef! !

!OBMessageNode class methodsFor: 'instance creation' stamp: ''!
on: aSelector inMethodNode: aNode
	^ self 
		on: aSelector 
		inMethod: aNode selector 
		inClass: aNode theClass! !

!OBMessageNode methodsFor: 'navigating' stamp: ''!
sendersOfMessage
	^ self sendersOf: message! !

!OBMessageNode class methodsFor: 'instance creation' stamp: ''!
fromMethodNode: aMethodNode
	^ self new 
		setMessage: aMethodNode selector
		selector: aMethodNode selector
		class: aMethodNode theClass! !

!OBMessageNode methodsFor: 'displaying' stamp: 'cwp 12/8/2004 21:26'!
name
	^ message! !

!OBMessageNode methodsFor: 'accessing' stamp: ''!
selection
	| methodNode assoc |
	methodNode := Parser new 
					parse: self source
					class: self theClass.
	assoc := (methodNode encoder rawSourceRanges) 
			associations detect: [:ea | ea key isMessage: message receiver: nil arguments: nil]
						ifNone: [nil -> (1 to: 0)].
						"Some messages are generated by the compiler."
	^ assoc value! !

!OBMessageNode methodsFor: 'navigating' stamp: ''!
implementors
	^ self implementorsOf: message! !

!OBMethodNode methodsFor: 'accessing' stamp: ''!
reference
	^ self referenceForMethod: selector ofClass: self theClassName! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 12/8/2004 23:48'!
implementorsOf: aSelector
	^ (SystemNavigation default allImplementorsOf: aSelector) asSortedArray
			collect: [:ref | OBMethodNode on: ref]! !

!OBMethodNode methodsFor: 'actions' stamp: ''!
fileOut
	self theClass fileOutMethod: selector! !

!OBMethodNode methodsFor: 'displaying' stamp: 'cwp 12/8/2004 21:08'!
name
	^ selector! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 10/18/2004 00:29'!
doRemove
	self theClass removeSelector: self selector.
	self signalDeletion! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 19:34'!
openChasingBrowser: graphName title: aString
	| browser panels |
	panels := {OBColumnPanel minPanes: 2 maxPanes: 2. 
			  OBListBrowser optionalButtonPanel.
			  OBListBrowser definitionPanel}.
	browser _ OBListBrowser graph: graphName root: self copy selection: nil panels: panels.
	browser 
		labelPrefix: aString;
		open! !

!OBMethodNode methodsFor: 'initializing' stamp: ''!
setSelector: aSelector class: aClass
	selector := aSelector.
	self theClass: aClass
! !

!OBMethodNode methodsFor: 'navigating' stamp: ''!
messages
	^ (((self theClass
				compiledMethodAt: self selector 
				ifAbsent: [^ #()]) messages) asSortedArray)
					collect: [:sel | OBMessageNode 
									on: sel 
									inMethod: selector 
									inClass: self theClass]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 15:42'!
browseVersions
	OBVersionBrowser openOn: self copy! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 18:03'!
browseInheritance
	OBInheritanceBrowser openRoot: self inheritanceRoot selection: self! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 10/17/2004 23:55'!
isDescendantOfMethodVersion: anOBMethodVersionNode 
	^ false! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 18:35'!
browse
	OBSystemBrowser openOnClass: self theClass selector: selector! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 12/5/2004 18:00'!
simpleBrowseSenders
	OBListBrowser browse: #Senders root: self! !

!OBMethodNode class methodsFor: 'instance creation' stamp: ''!
on: aSelector inClass: aClassReference
	^ self new setSelector: aSelector class: aClassReference! !

OBMethodNode subclass: #OBClassRefNode
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassRefNode methodsFor: 'accessing' stamp: 'cwp 12/8/2004 22:14'!
name
	^ className! !

!OBClassRefNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/1/2004 00:50'!
on: aClassName inMethod: aMethodRef
	^ self new setClassName: aClassName reference: aMethodRef! !

!OBClassRefNode methodsFor: 'accessing' stamp: 'cwp 12/1/2004 01:16'!
selection
	| start parser |
	(parser _ Compiler parserClass new) parseSelector: self source.
	start := parser endOfLastToken.
	start := (self source asString findString: className startingAt: start).
	^ start to: start + className size - 1! !

!OBClassRefNode methodsFor: 'initialize-release' stamp: 'cwp 12/1/2004 01:10'!
setClassName: theName reference: aMethodRef
	self setReference: aMethodRef.
	className := theName.
! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 11/25/2004 22:49'!
browseSenders
	self browseTitle: 'Senders of' metagraph: #Senders! !

!OBMethodNode methodsFor: 'private' stamp: ''!
messageSelectors
	^ ((self theClass compiledMethodAt: self selector ifAbsent: [^ #()]) messages) asSortedArray! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 12/1/2004 00:37'!
selection
	^ 1 to: 0! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/1/2004 00:36'!
source
	^ (self theClass sourceCodeAt: self selector ifAbsent: [^ '']) 
		asText makeSelectorBold! !

!OBMethodNode methodsFor: 'printing' stamp: 'cwp 12/8/2004 21:59'!
printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $<;
		nextPutAll: self theClass name;
		nextPut: $#;
		nextPutAll: self selector;
		nextPut: $>! !

!OBMethodNode methodsFor: 'ancestry' stamp: ''!
ancestrySelector
	^ #isDescendantOfMethod: ! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 20:07'!
browseTitle: aString metagraph: aSymbol 
	OBListBrowser 
		browse: aSymbol
		root: self copy
		title: aString! !

!OBMethodNode methodsFor: 'private' stamp: ''!
sourcePointer
	^ (self theClass compiledMethodAt: self selector) sourcePointer! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 11/28/2004 10:37'!
isDescendantOfMethod: other
	^ other selector = selector
		and: [self theClass withAllSuperclasses includes: other theClass].
	! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 20:13'!
actions
	^{ 
		self action: #fileOut withLabel: 'file out'.
		self 
			action: #browse
			withMenuLabel: 'browse'
			withButtonLabel: 'browse'
			withKeystroke: $b
			withIcon: MenuIcons windowIcon.
		self 
			action: #browseSenders
			withMenuLabel: 'senders'
			withButtonLabel: 'senders'
			withKeystroke: $n
			withIcon: MenuIcons findIcon.
		self 
			action: #browseImplementors
			withMenuLabel: 'implementors'
			withButtonLabel: 'implementors'
			withKeystroke: $m
			withIcon: MenuIcons findIcon.
		self 
			action: #browseVersions
			buttonLabel: 'versions'
			menuLabel: 'versions'.
		self 
			action: #browseInheritance
			buttonLabel: 'inheritance'
			menuLabel: 'inheritance'.
		self 
			action: #chaseVars
			buttonLabel: 'variables'
			menuLabel: 'chase variables'.
		self 
			action: #remove
			withLabel: 'remove'
			withKeystroke: $x
			withIcon: MenuIcons deleteIcon}! !

!OBMethodNode methodsFor: 'navigating' stamp: ''!
senders
	^ self sendersOf: selector! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 10/18/2004 00:30'!
remove
	| senders choice |
	senders _ SystemNavigation default allCallsOn: self selector.
	senders isEmpty ifTrue: [^ self doRemove].
	choice _ OBChoiceRequest
				prompt: 'This message has ', senders size asString, ' senders.'
				labels: #('Remove it' 
						'Remove, then browse senders' 
						'Don''t remove, but show me those senders' 
						'Forget it -- do nothing -- sorry I asked')
				values: #(doRemove removeAndBrowse simpleBrowseSenders nil).
	choice ifNotNil: [^ self perform: choice]
! !

!OBMethodNode methodsFor: 'comparing' stamp: 'cwp 12/8/2004 22:07'!
hash
	^ theClass hash bitXor: selector hash! !

!OBMethodNode methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!OBMethodNode methodsFor: 'navigating' stamp: ''!
versions
	^ (OBMethodVersion scan: self sourceFiles from: self sourcePointer)
		collect: [:ea | OBMethodVersionNode on: ea]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 11/25/2004 22:48'!
browseImplementors
	self browseTitle: 'Implementors of' metagraph: #Implementors! !

!OBMethodNode methodsFor: 'private' stamp: ''!
removeAndBrowse
	self simpleBrowseSenders.
	self theClass removeSelector: self selector.
	self signalDeletion! !

!OBMethodNode methodsFor: 'navigating' stamp: ''!
selectorAndMessages
	^ self messages copyWithFirst: self messageNode! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 19:34'!
chaseImplementors
	self openChasingBrowser: #ChaseImplementors title: 'Implementors of'! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 12/1/2004 00:36'!
definition
	^ OBMethodDefinition
		selection: self selection
		source: self source
		inClass: self theClass! !

!OBMethodNode methodsFor: 'ancestry' stamp: 'cwp 12/2/2004 23:28'!
isDescendantOfMethodCat: aMethodCatNode
	^ (self theClass organization categoryOfElement: self selector) = aMethodCatNode name! !

!OBMethodNode methodsFor: 'comparing' stamp: 'cwp 12/8/2004 22:07'!
= other
	^ (self species = other species)
		and: [self theClass = other theClass] 
		and: [self selector = other selector]! !

!OBMethodNode methodsFor: 'initializing' stamp: ''!
setReference: aMethodReference
	self 
		setSelector: aMethodReference methodSymbol
		class: (aMethodReference actualClass)! !

!OBMethodNode methodsFor: 'private' stamp: 'cwp 12/8/2004 23:49'!
inheritanceRoot
	| rootClass |
	rootClass := (self theClass withAllSuperclasses asArray
					select: [:ea | ea includesSelector: self selector]) last.
	^ OBCollectionNode on: {OBMethodNode 
								on: self selector 
								inClass: rootClass}! !

!OBMethodNode methodsFor: 'private' stamp: ''!
addOverridersOf: aSelector inClass: aClass to: aCollection
	aClass subclasses do: 
		[:ea | (ea includesSelector: aSelector)
					ifTrue: [aCollection add: ea]
					ifFalse: [self addOverridersOf: aSelector inClass: ea to: aCollection]]! !

!OBMethodNode methodsFor: 'displaying' stamp: 'cwp 12/8/2004 21:08'!
fullName
	^ self theClassName, '>>', selector! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 12/8/2004 23:49'!
overrides
	| classes |
	classes := OrderedCollection new.
	self addOverridersOf: self selector inClass: self theClass to: classes.
	^ classes collect: [:ea | OBMethodNode on: selector inClass: ea] ! !

!OBMethodNode class methodsFor: 'instance creation' stamp: ''!
on: aMethodReference
	^ self new setReference: aMethodReference! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:04'!
sortsBefore: aClassNode
	| own other |
	own := self withSuperiors.
	other := aClassNode withSuperiors.
	1 	to: (own size min: other size)
		do: [:i | (own at: i) == (other at: i) ifFalse: 
				[^ (own at: i) theClassName <= (other at: i) theClassName]].
	^ other includes: self
	! !

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theNonMetaClass
	^ self theClass theNonMetaClass! !

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theClass: aClass
	theClass := aClass! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:03'!
superiorClass
	^superior ifNotNil: [superior theClass]! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:03'!
superior
	^ superior! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:04'!
adoptSuperior: other 
	| descent |
	descent := self theClass allSuperclasses reversed.
	(descent indexOf: other theClass) > (descent indexOf: self superiorClass) 
		ifTrue: [superior := other]! !

OBClassAwareNode subclass: #OBMethodCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodCategoryNode methodsFor: 'actions' stamp: ''!
fileOut
	self theClass fileOutCategory: name! !

!OBMethodCategoryNode methodsFor: 'public' stamp: ''!
accept: aText notifying: aController
	| selector |
	selector := self compileMethod: aText notifying: aController.
	selector ifNil: [^ false].
	(self methodNodeFor: selector) signalSelection! !

!OBMethodCategoryNode methodsFor: 'public' stamp: ''!
name
	^ name! !

!OBMethodCategoryNode methodsFor: 'public' stamp: ''!
textSelection
	^ 1 to: self text size! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: ''!
category
	^ name! !

!OBMethodCategoryNode methodsFor: 'drag and drop' stamp: ''!
dropSelector
	^ #dropOnMethodCategory:! !

!OBMethodCategoryNode class methodsFor: 'actions' stamp: 'cwp 9/18/2004 22:58'!
actionsForParent: aNode
	^ #()! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: ''!
ancestrySelector
	^ #isDescendantOfMethodCat:! !

!OBMethodCategoryNode class methodsFor: 'instance creation' stamp: ''!
on: aString inClass: aClassReference
	^ self new setName: aString class: aClassReference! !

OBMethodCategoryNode subclass: #OBAllMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBAllMethodCategoryNode methodsFor: 'accessing' stamp: ''!
methodReferences
	^ self theClass selectors asSortedArray 
		collect: [:ea | MethodReference new setStandardClass: self theClass methodSymbol: ea]! !

!OBAllMethodCategoryNode methodsFor: 'accessing' stamp: ''!
category
	^ 'as yet unclassified'! !

!OBAllMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: ''!
on: className
	^ self on: '-- all --' inClass: className! !

!OBMethodCategoryNode methodsFor: 'ancestry' stamp: ''!
isDescendantOfMethodCat: other
	^ (other theClassName = self theClassName) and: [other name = name]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: ''!
text
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBMethodCategoryNode methodsFor: 'public' stamp: ''!
definition
	^ OBMethodDefinition inCategory: self category inClass: self theClass! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: ''!
methodReferences
	^ (self theClass organization listAtCategoryNamed: name)
		collect: [:ea | MethodReference new
						setClassSymbol: self theNonMetaClassName
						classIsMeta: self theClass isMeta
						methodSymbol: ea
						stringVersion: '']! !

!OBMethodCategoryNode methodsFor: 'navigating' stamp: ''!
methods
	^ self methodReferences collect: [:ref | OBMethodNode on: ref]! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 9/19/2004 00:11'!
remove
	self theClass removeCategory: name.
	self signalDeletion! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: ''!
browse
	Browser fullOnClass: self theClass! !

!OBMethodCategoryNode methodsFor: 'initializing' stamp: ''!
setName: aString class: aClass
	name := aString.
	self theClass: aClass! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: ''!
container
	^ self theClass! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 18:46'!
actions
	^ Array
		with: (self action: #fileOut withLabel: 'file out')
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		with: (self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables')
! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 12/5/2004 20:17'!
chaseVars
	OBListBrowser 
		browse: #Variables
		root: self classNode
		title: 'Variables of'! !

OBClassAwareNode subclass: #OBVariableNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBVariableNode class methodsFor: 'instance creation' stamp: ''!
on: instVarName inClass: aClassReference 
	^ self new setName: instVarName class: aClassReference! !

!OBVariableNode methodsFor: 'initializing' stamp: ''!
setName: aString class: aClass
	name := aString.
	self theClass: aClass! !

OBVariableNode subclass: #OBClassVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassVariableNode methodsFor: 'navigating' stamp: 'cwp 12/8/2004 23:47'!
accessors
	| literal |
	literal := (self theClass withAllSuperclasses 
				gather: [:ea | ea classPool associations])
					detect: [:ea | ea key = name].
	^ ((self systemNavigation allCallsOn: literal) asArray sort)
		collect: [:ref | OBMethodNode on: ref]! !

OBVariableNode subclass: #OBInstanceVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBInstanceVariableNode methodsFor: 'navigating' stamp: 'cwp 12/8/2004 23:48'!
accessors
	| accessors |
	accessors := OrderedCollection new.
	self theClass withAllSubAndSuperclassesDo: [:class |
		(class whichSelectorsAccess: name) asSortedCollection
			do: [:ea | ea = #DoIt ifFalse: [accessors add: 
					(self referenceForMethod: ea ofClass: class name)]]].
	^ accessors asArray	collect: [:ref | OBMethodNode on: ref]! !

!OBVariableNode methodsFor: 'actions' stamp: ''!
actions
	^ Array
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
! !

!OBVariableNode methodsFor: 'displaying' stamp: ''!
name
	^ name! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:03'!
superiors
	| result |
	result := OrderedCollection new.
	self superiorsDo: [:ea | result add: ea].
	^ result asArray reversed! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: 'cwp 12/5/2004 12:56'!
isDescendantOfClassCat: aClassCategoryNode

	"optimized version: sending #category to the class is slow"
	^ (self theNonMetaClass environment organization 
		listAtCategoryNamed: aClassCategoryNode name)
			includes: self theNonMetaClassName

! !

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theMetaClass
	^ self theClass theMetaClass! !

!OBClassAwareNode methodsFor: 'displaying' stamp: 'cwp 12/12/2004 22:29'!
indent
	| size indent |
	size := 0.
	self superiorsDo: [:ea | size := size + 1].
	indent := String new: size.
	indent atAllPut: $ .
	^ indent! !

!OBClassAwareNode methodsFor: 'accessing' stamp: ''!
theClassName
	^ self theClass name! !

OBClassAwareNode subclass: #OBClassCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassCommentNode methodsFor: 'initializing' stamp: ''!
setClass: aClass
	self theClass: aClass! !

!OBClassCommentNode methodsFor: 'definition' stamp: ''!
text
	^ self theClass comment! !

!OBClassCommentNode methodsFor: 'definition' stamp: ''!
text: aText
	self theClass comment: aText stamp: Utilities changeStamp.
	^ true! !

!OBClassCommentNode methodsFor: 'actions' stamp: ''!
actions
	^ Array
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		with: (self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables')! !

!OBClassCommentNode methodsFor: 'public' stamp: 'cwp 12/13/2004 00:50'!
indentedName
	^ self indent, self name! !

!OBClassCommentNode methodsFor: 'public' stamp: 'cwp 12/13/2004 00:51'!
name
	^ self theClass name! !

!OBClassCommentNode class methodsFor: 'as yet unclassified' stamp: ''!
on: classRef
	^ self new setClass: classRef! !

OBClassAwareNode subclass: #OBMethodVersionNode
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMethodVersionNode methodsFor: 'displaying' stamp: 'cwp 11/27/2004 21:38'!
name
	| stamp |
	stamp := version stamp ifNil: ['<timestamp missing>'].
	^ version theClassName, '>>', version selector, ' ', stamp! !

!OBMethodVersionNode methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:57'!
category
	^ self theClass organization categoryOfElement: version selector! !

!OBMethodVersionNode methodsFor: 'compiling' stamp: 'cwp 10/17/2004 23:53'!
definition
	^ (OBMethodDefinition source: version source inClass: self theClass)
		callback: [:sel | 
					version selector = sel
						ifTrue: [self class on: version latest]
						ifFalse: [OBMethodNode on: sel inClass: self theClass]]! !

!OBMethodVersionNode class methodsFor: 'instance creation' stamp: ''!
on: aMethodVersion 
	^ self new setVersion: aMethodVersion! !

!OBMethodVersionNode methodsFor: 'actions' stamp: ''!
actions
	^ {self action: #browse buttonLabel: 'browse' menuLabel: 'browse in standard browser'.
	   self action: #revert buttonLabel: 'revert' menuLabel: 'revert to selected version'}! !

!OBMethodVersionNode methodsFor: 'ancestry' stamp: 'cwp 10/17/2004 23:43'!
isDescendantOfMethodVersion: aNode
	^ (version = aNode version)! !

!OBMethodVersionNode methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:44'!
version
	^ version! !

!OBMethodVersionNode methodsFor: 'initializing' stamp: ''!
setVersion: aMethodVersion
	version := aMethodVersion.
	self theClass: version theClass! !

!OBMethodVersionNode methodsFor: 'actions' stamp: ''!
revert
	version fileIn! !

!OBMethodVersionNode methodsFor: 'accessing' stamp: ''!
reference
	^ self referenceForMethod: version selector ofClass: self theClassName.! !

!OBMethodVersionNode methodsFor: 'actions' stamp: ''!
browse
	| class method |
	class := self theClass.
	method := (class compiledMethodAt: version selector).
	VersionsBrowser
		browseVersionsOf: method
		class: class
		meta: class isMeta
		category: self category
		selector: version selector! !

!OBMethodVersionNode methodsFor: 'ancestry' stamp: 'cwp 10/17/2004 23:41'!
ancestrySelector
	^ #isDescendantOfMethodVersion:! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:03'!
superiorsDo: aBlock
	| cursor |
	cursor := superior.
	[cursor isNil] whileFalse:
		[aBlock value: cursor.
		cursor := cursor superior]! !

!OBClassAwareNode methodsFor: 'actions' stamp: 'cwp 12/15/2004 21:29'!
browse
	OBSystemBrowser openOnClass: self theClass! !

!OBClassAwareNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2004 22:13'!
sortHierarchically: nodes
	nodes do: [:a | nodes do: [:b | a adoptSuperior: b]].
	nodes sort: [:a : b | a sortsBefore: b].
	^ nodes! !

!OBClassAwareNode methodsFor: 'superiors' stamp: 'cwp 12/11/2004 22:03'!
withSuperiors
	| result |
	result := OrderedCollection new.
	result add: self.
	self superiorsDo: [:ea | result add: ea].
	^ result asArray reversed! !

OBClassAwareNode subclass: #OBClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassNode methodsFor: 'navigating' stamp: ''!
classVariables
	^ self theClass allClassVarNames asArray sort
		collect: [:ea | OBClassVariableNode on: ea inClass: self theClass]! !

!OBClassNode methodsFor: 'ancestry' stamp: ''!
ancestrySelector
	^ #isDescendantOfClass:! !

!OBClassNode methodsFor: 'navigating' stamp: ''!
categories
	^ (self theClass organization categories
		collect: [:cat | OBMethodCategoryNode on: cat inClass: self theClass])
			copyWithFirst: self allCategory! !

!OBClassNode methodsFor: 'accessing' stamp: ''!
definition
	^ OBClassDefinition 
		environment: self theClass environment 
		template: self theClass definition! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 12/8/2004 23:45'!
users
	^ (SystemNavigation default allCallsOn: (theClass environment associationAt: theClass name))
		collect: [:ref | OBClassRefNode on: self name inMethod: ref]! !

!OBClassNode methodsFor: 'drag and drop' stamp: ''!
dropOnClassCategory: aNode
	self theClass category: aNode name.
	self signalSelection! !

!OBClassNode methodsFor: 'displaying' stamp: ''!
title
	^ self name! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 23:31'!
classHierarchy
	^ self nodeHierarchyWithClass: OBClassNode! !

!OBClassNode methodsFor: 'displaying' stamp: 'cwp 12/13/2004 00:56'!
indentedName
	^ self indent, self name! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 23:30'!
metaclassHierarchy
	^ self nodeHierarchyWithClass: OBMetaclassNode! !

!OBClassNode methodsFor: 'nodes' stamp: ''!
classCategoryNode
	^ OBClassCategoryNode 
		on: self theNonMetaClass category
		inEnvironment: self theClass environment! !

!OBClassNode methodsFor: 'initializing' stamp: ''!
setClass: aClass
	self theClass: aClass! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 10/26/2004 00:49'!
fileOut
	self theNonMetaClass fileOut! !

!OBClassNode methodsFor: 'navigating' stamp: ''!
instanceVariables
	^ self theClass allInstVarNames asArray sort
		collect: [:ea | OBInstanceVariableNode on: ea inClass: self theClass]! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 12/2/2004 23:06'!
actions
	^ {
		self action: #findMethod withLabel: 'find method...' withKeystroke: $f withIcon: MenuIcons findIcon.
		self action: #fileOut withLabel: 'file out'.
		self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser'.
		self action: #chaseVars buttonLabel: 'variables' menuLabel: 'chase variables'.
		self action: #inspectInstances withLabel: 'inspect instances'.
		self action: #inspectSubInstances withLabel: 'inspect subinstances'}! !

!OBClassNode methodsFor: 'actions' stamp: ''!
browse
	Browser fullOnClass: self theClass! !

!OBClassNode methodsFor: 'actions' stamp: ''!
inspectSubInstances
	self theNonMetaClass inspectSubInstances! !

!OBClassNode methodsFor: 'accessing' stamp: ''!
organization
	^ self theClass organization! !

!OBClassNode class methodsFor: 'instance creation' stamp: 'cwp 11/30/2004 21:06'!
on: aClass 
	^ self new setClass: aClass ! !

OBClassNode subclass: #OBMetaclassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBMetaclassNode methodsFor: 'initializing' stamp: ''!
setClass: aClass
	super setClass: aClass theMetaClass
		! !

!OBMetaclassNode methodsFor: 'displaying' stamp: 'cwp 12/13/2004 00:56'!
name 
	^ self nonMetaName! !

!OBMetaclassNode methodsFor: 'displaying' stamp: ''!
nonMetaName
	^ self theNonMetaClass name! !

!OBClassNode methodsFor: 'actions' stamp: ''!
findMethod
	| selectors selection |
	selectors := self theClass selectors asSortedArray.
	selectors isEmpty ifTrue: [^nil].
	selection := OBChoiceRequest labels: selectors.
	selection ifNotNil: [(OBMethodNode 
									on: selection
									inClass: self theClass) signalSelection].! !

!OBClassNode methodsFor: 'printing' stamp: 'cwp 12/10/2004 23:53'!
printOn: aStream
	aStream
		print: self class;
		nextPut: $<;
		print: self theClass;
		nextPut: $>! !

!OBClassNode methodsFor: 'accessing' stamp: 'cwp 12/12/2004 23:27'!
surroundingHierarchy
	 ^ (self theClass withAllSuperclasses union: self theClass allSubclasses)
		asArray! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 23:30'!
nodeHierarchyWithClass: aClass
	^ OBClassAwareNode sortHierarchically: 
		(self surroundingHierarchy collect: [:ea | aClass on: ea])! !

!OBClassNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 23:31'!
commentHierarchy
	^ self nodeHierarchyWithClass: OBClassCommentNode! !

!OBClassNode methodsFor: 'actions' stamp: ''!
inspectInstances
	self theNonMetaClass inspectAllInstances! !

!OBClassNode methodsFor: 'accessing' stamp: 'cwp 12/12/2004 22:45'!
= other
	self species = other species ifFalse: [^ false].
	^ self theClass = other theClass! !

!OBClassNode methodsFor: 'navigating' stamp: ''!
allCategory
	^ OBAllMethodCategoryNode on: self theClass! !

!OBClassNode methodsFor: 'displaying' stamp: 'cwp 12/13/2004 00:51'!
name
	^ self theClass name! !

!OBClassAwareNode methodsFor: 'ancestry' stamp: ''!
isDescendantOfClass: aClassNode
	^ self theClassName = aClassNode theClassName! !

OBCodeNode subclass: #OBClassCategoryNode
	instanceVariableNames: 'environment name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBClassCategoryNode class methodsFor: 'actions' stamp: ''!
userSelectionOf: classNames for: toMatch 
	| exactMatch lines index |
	exactMatch := classNames	detect: [:ea | ea asLowercase = toMatch] 
								ifNone: [nil].
	lines := #().
	exactMatch ifNotNil:	[classNames copyWithFirst: exactMatch.
							lines := #(1)].
	index := (PopUpMenu labelArray: classNames lines: lines) startUp.
	index isZero
		ifTrue: [^ nil].
	^ (classNames at: index) asSymbol! !

!OBClassCategoryNode methodsFor: 'drag and drop' stamp: ''!
dropSelector
	^ #dropOnClassCategory:! !

!OBClassCategoryNode methodsFor: 'accessing' stamp: 'cwp 9/22/2004 22:13'!
container
	^ environment! !

!OBClassCategoryNode methodsFor: 'private' stamp: ''!
classNames
	^ environment organization listAtCategoryNamed: name! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: ''!
isDescendantOfClassCat: other
	^ other name = name! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 22:12'!
classesHierarchically
	^ OBClassAwareNode sortHierarchically: self classes! !

!OBClassCategoryNode methodsFor: 'initializing' stamp: ''!
setName: aString environment: anEnvironment
	name := aString asSymbol.
	environment := anEnvironment! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 22:19'!
commentsHierarchically
	^ OBClassAwareNode sortHierarchically: self comments! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: ''!
classes
	^ self classNames collect: [:ea | OBClassNode on: (environment at: ea)]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: ''!
actions
	^ Array
		with: (self action: #fileOut withLabel: 'file out')
		with: (self action: #browse buttonLabel: 'browse' menuLabel: 'view in standard browser')
		! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: ''!
definition
	^ OBClassDefinition 
		environment: environment 
		template: ((environment at: #Class) template: name)! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: ''!
metaclasses
	^ self classNames collect: [:ea | OBMetaclassNode on: (environment at: ea)]! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: ''!
findClassIn: anEnvironment
	| pattern className |
	pattern := OBTextRequest 
					prompt: 'Please type the name or fragment to look for' 
					template: ''.
	pattern ifNil: [^self].
	className := self findClassIn: anEnvironment pattern: pattern.
	className ifNotNil: [(OBClassNode on: className) signalSelection].! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: ''!
name
	^ name! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: ''!
comments
	^ self classNames collect: [:ea | OBClassCommentNode on: (environment at: ea)]! !

!OBClassCategoryNode methodsFor: 'class creation' stamp: ''!
isRedefinedBy: definition
	"No class is selected, so the definition can't be a redefinition."
	
	^ false! !

!OBClassCategoryNode methodsFor: 'actions' stamp: ''!
browse
	Browser newOnCategory: name! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: ''!
actionsForParent: aNode
	^ Array with: (OBAction
						label: 'find class...'
						receiver: self
						selector: #findClassIn:
						arguments: (Array with: aNode environment)
						keystroke: $f)
! !

!OBClassCategoryNode methodsFor: 'ancestry' stamp: ''!
ancestrySelector
	^ #isDescendantOfClassCat:! !

!OBClassCategoryNode methodsFor: 'initializing' stamp: ''!
setName: aString
	self setName: aString environment: self class environment! !

!OBClassCategoryNode methodsFor: 'actions' stamp: ''!
printOut
	environment organization fileOutCategory: name asHtml: true! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 9/19/2004 00:11'!
remove
	environment organization removeSystemCategory: name.
	self signalDeletion! !

!OBClassCategoryNode methodsFor: 'navigating' stamp: 'cwp 12/12/2004 22:19'!
metaclassesHierarchically
	^ OBClassAwareNode sortHierarchically: self metaclasses! !

!OBClassCategoryNode methodsFor: 'displaying' stamp: ''!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self name, ''''! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: ''!
findClassIn: anEnvironment pattern: pattern
	| classNames className toMatch potentialClassNames |
	toMatch := (pattern copyWithout: $.) asLowercase.
	potentialClassNames := anEnvironment classNames asArray.
	classNames := pattern last = $.
					ifTrue: [potentialClassNames
							select: [:nm | nm asLowercase = toMatch]]
					ifFalse: [potentialClassNames
							select: [:n | n includesSubstring: toMatch caseSensitive: false]].
	classNames size = 0 ifTrue: [^ nil].
	classNames size = 1 ifTrue: [^ anEnvironment at: classNames first asSymbol].
	className := self userSelectionOf: classNames for: (pattern copyWithout: $.) asLowercase.
	^ className ifNotNil: [anEnvironment at: className asSymbol]! !

!OBClassCategoryNode class methodsFor: 'instance creation' stamp: ''!
on: aString inEnvironment: anEnvironment
	^ self new setName: aString environment: anEnvironment! !

!OBClassCategoryNode methodsFor: 'actions' stamp: ''!
fileOut
	environment organization fileOutCategory: name.! !

!OBClassCategoryNode class methodsFor: 'instance creation' stamp: ''!
on: aString
	^ self new setName: aString! !

OBCodeNode subclass: #OBSelectorNode
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBSelectorNode methodsFor: 'accessing' stamp: 'cwp 10/31/2004 01:11'!
selector
	^ selector! !

!OBSelectorNode methodsFor: 'navigating' stamp: 'cwp 12/8/2004 23:48'!
implementors
	^ (SystemNavigation default allImplementorsOf: self selector) asSortedArray
			collect: [:ref | OBMethodNode on: ref]! !

!OBSelectorNode methodsFor: 'navigating' stamp: 'cwp 10/31/2004 01:12'!
name
	^ selector printString! !

!OBSelectorNode methodsFor: 'navigating' stamp: 'cwp 10/31/2004 01:48'!
sendersOfMessage
	^ (SystemNavigation default allCallsOn: self selector) asSortedArray
			collect: [:ref | OBMessageNode on: self selector inMethodReference: ref]! !

!OBSelectorNode methodsFor: 'accessing' stamp: 'cwp 10/31/2004 01:10'!
selector: aSelector
	selector := aSelector! !

!OBSelectorNode class methodsFor: 'instance creation' stamp: 'cwp 10/31/2004 01:11'!
on: aSelector
	^ self new selector: aSelector! !

!OBSelectorNode methodsFor: 'navigating' stamp: 'cwp 10/31/2004 01:12'!
selectorAndMessages
	^ Array with: self! !

!OBSelectorNode methodsFor: 'navigating' stamp: 'cwp 11/1/2004 02:22'!
senders
	^ (SystemNavigation default allCallsOn: self selector) asSortedArray
			collect: [:ref | OBMessageNode on: self selector inMethodReference: ref]! !

OBCodeNode subclass: #OBEnvironmentNode
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Nodes'!

!OBEnvironmentNode class methodsFor: 'as yet unclassified' stamp: ''!
on: anEnvironment
	^ self new setEnvironment: anEnvironment! !

!OBEnvironmentNode methodsFor: 'initializing' stamp: ''!
setEnvironment: anEnvironment
	environment := anEnvironment! !

!OBEnvironmentNode methodsFor: 'accessing' stamp: ''!
environment
	^ environment! !

!OBEnvironmentNode methodsFor: 'accessing' stamp: ''!
organization
	^ self environment organization! !

!OBEnvironmentNode methodsFor: 'navigating' stamp: ''!
categories
	^ environment organization categories collect: [:cat | OBClassCategoryNode 
															on: cat
															inEnvironment: environment]! !

!OBEnvironmentNode methodsFor: 'displaying' stamp: ''!
name 
	^ 'Squeak'! !

!OBEnvironmentNode class methodsFor: 'as yet unclassified' stamp: ''!
forImage
	^ self on: Smalltalk! !

!Metaclass methodsFor: '*ob-standard-converting' stamp: ''!
asNode
	^ (OBMetaclassNode on: self)! !

Notification subclass: #OBSourceFilesRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Notifications'!

!OBSourceFilesRequest methodsFor: 'exceptionDescription' stamp: ''!
defaultAction
	^ SourceFiles! !

!OBSourceFilesRequest methodsFor: 'exceptionDescription' stamp: 'cwp 11/27/2004 22:49'!
isBrowseRequest
	^ false! !

BogusTestCase subclass: #OBOrganizationDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 9/22/2004 22:08'!
definition
	^ OBOrganizationDefinition on: BogusA organization! !

!OBOrganizationDefinitionTest methodsFor: 'tests' stamp: 'cwp 9/23/2004 22:00'!
testAccept
	| definition |
	definition _ self definition.
	definition accept: self newOrgText notifying: self.
	damage add: #Categories ofClass: #BogusA.
	self assert: definition text = self newOrgText.
	self assert: BogusA organization asString = self newOrgText! !

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 11/6/2004 23:17'!
orgText
	^ '(''letters'' a b)
(''numbers'' five one three two)
(''other'' bogusHopefullyUniqueSelector bogusOtherUniqueSelector isString)
(''*bogusext'' foo)
(''*bogusext-testing'' isFake)
'! !

!OBOrganizationDefinitionTest methodsFor: 'tests' stamp: 'cwp 9/22/2004 22:31'!
testDisplay
	self assert: self definition text = self orgText! !

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 11/6/2004 23:18'!
newOrgText
	^ '(''alphanum'' a b five one three two)
(''other'' bogusHopefullyUniqueSelector bogusOtherUniqueSelector isString)
(''*bogusext'' foo)
(''*bogusext-testing'' isFake)
'
! !

BogusTestCase subclass: #OBActorTest
	instanceVariableNames: 'notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBActorTest methodsFor: 'asserting' stamp: ''!
assertActions: actions includeLabels: expected
	| actual |
	actual := actions collect: [:ea | ea label].
	self assert: (actual includesAllOf: expected)
	! !

!OBActorTest methodsFor: 'fetching' stamp: ''!
actionNamed: aName forParent: aNode
	| action |
	action := (OBCategoryActor new actionsForParent: aNode) 
				detect: [:ea | ea label = aName].
	action monitor: self.
	^ action! !

OBActorTest subclass: #OBCategoryActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/18/2004 23:49'!
testNoSystemAutoCat
	| action |
	action := (OBCategoryActor new actionsForParent: self envNode) 
				detect: [:ea | ea label = 'categorize automatically'] ifNone: [nil].
	self assert: action isNil! !

!OBCategoryActorTest methodsFor: 'tests' stamp: ''!
testSortMethodCats
	| remove |
	BogusA organization addCategory: 'zzz' before: BogusA organization categories first.
	remove := self actionNamed: 'alphabetize categories' forParent: self classNode.
	remove trigger.
	damage add: #Categories ofClass: #BogusA.
	self assert: BogusA organization categories = BogusA organization categories asSortedArray! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/23/2004 22:29'!
testCategorizeAll
	| classify |
	BogusA  organization classify: #beep under: (Categorizer default).
	damage add: #Categories ofClass: #BogusA.
	classify := self actionNamed: 'categorize automatically' forParent: self classNode.
	classify trigger.
	self deny: (BogusA organization categories includes: (Categorizer default)).
	self assert: (BogusA organization categoryOfElement: #beep) 
					= (Object organization categoryOfElement: #beep).
	BogusA organization removeElement: #beep	! !

!OBCategoryActorTest methodsFor: 'constants' stamp: 'cwp 9/22/2004 20:59'!
parentLabels
	^ #('create category...' 
		'alphabetize categories' 
		'remove empty categories' 
		'categorize automatically'
		'reorganize categories').! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/23/2004 23:26'!
testCreateClassCat
	| remove |
	remove := self actionNamed: 'create category...' forParent: self envNode.
	[remove trigger]
		on: OBTextRequest
		do: [:n | self assert: n template = 'Category-Name']! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/18/2004 21:47'!
testRemoveEmptyMethodCats
	| remove |
	BogusA  organization addCategory: #zletters.
	damage add: #Categories ofClass: #BogusA.
	remove := self actionNamed: 'remove empty categories' forParent: self classNode.
	remove trigger.
	self deny: (BogusA organization categories includes: #zletters)! !

!OBCategoryActorTest methodsFor: 'constants' stamp: ''!
selectedNode
	^ self classCatNode! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/22/2004 20:55'!
testReorganize
	| action |
	action := self actionNamed: 'reorganize categories' forParent: self classNode.
	action trigger.
	self assert: notification definition notNil.
	self assert: notification definition text = self organization. ! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/23/2004 23:24'!
testCreateMethodCat
	| remove |
	remove := self actionNamed: 'create category...' forParent: self classNode.
	[remove trigger]
		on: OBTextRequest
		do: [:n | self assert: n template = 'category name'.
				n resume: 'zletters'].
	damage add: #Categories ofClass: #BogusA.
	self assert: (BogusA organization categories includes: #zletters)! !

!OBCategoryActorTest methodsFor: 'constants' stamp: ''!
parentNode
	^ self classNode! !

!OBCategoryActorTest methodsFor: 'constants' stamp: ''!
nodeLabels
	^ #('remove' 'rename...').! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/17/2004 00:39'!
testRemoveMethodCat
	| remove |
	remove := self actionNamed: 'remove' forNode: self methCatNode.
	[remove trigger]
		on: OBConfirmationRequest
		do: [:n | n resume: true].
	damage add: #a ofClass: #BogusA.
	damage add: #b ofClass: #BogusA.
	self deny: (BogusA organization categories includes: #letters)! !

!OBCategoryActorTest methodsFor: 'constants' stamp: ''!
actor
	^ OBCategoryActor new! !

!OBCategoryActorTest methodsFor: 'constants' stamp: 'cwp 11/7/2004 00:06'!
organization
	^  '(''letters'' a b)
(''numbers'' five one three two)
(''other'' bogusHopefullyUniqueSelector bogusOtherUniqueSelector isString)
(''*bogusext'' foo)
(''*bogusext-testing'' isFake)
'! !

!OBCategoryActorTest methodsFor: 'tests' stamp: 'cwp 9/17/2004 00:39'!
testRenameMethodCat
	| rename |
	rename := self actionNamed: 'rename...' forNode: self methCatNode.
	[rename trigger]
		on: OBTextRequest
		do: [:n | n resume: 'zletters'].
	damage add: #Categories ofClass: #BogusA.
	self deny: (BogusA organization categories includes: #letters).
	self assert: (BogusA organization categories includes: #zletters)! !

!OBActorTest methodsFor: 'constants' stamp: ''!
nodeLabels
	^ #()! !

!OBActorTest methodsFor: 'tests' stamp: ''!
testNodeLabels
	| actions |
	actions := self actor actionsForNode: self selectedNode.
	self assertActions: actions includeLabels: self nodeLabels
	! !

!OBActorTest methodsFor: 'emulating' stamp: 'cwp 9/17/2004 00:38'!
notification: aNotification
	notification _ aNotification! !

OBActorTest subclass: #OBClassActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Tests'!

!OBClassActorTest methodsFor: 'asserting' stamp: 'cwp 11/16/2004 23:43'!
assertCorrectBrowser: aBrowser
	self assert: (aBrowser isKindOf: OBListBrowser)! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 9/17/2004 00:47'!
testSubclassTemplate
	| action |
	action := self actionNamed: 'subclass template' forNode: self classNode.
	action trigger.
	self assert: notification definition notNil.
	self assert: notification definition text = self subclassTemplate. ! !

!OBClassActorTest methodsFor: 'constants' stamp: ''!
parentLabels
	^ #()! !

!OBClassActorTest methodsFor: 'constants' stamp: ''!
actor
	^ OBClassActor new! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 11/30/2004 22:13'!
testRenamedReferences
	| rename raised |
	damage addRenameOf: #BogusA to: #BogusX.
	raised _ false.
	rename := self actionNamed: 'rename...' forNode: self classNode.
	[rename trigger] 
		on: OBTextRequest, OBBrowseRequest
		do: [:n | n isBrowseRequest	
					ifTrue: [self assertCorrectBrowser: n browser.
							raised _ true]
					ifFalse: [n resume: 'BogusX']].
	self assert: raised.! !

!OBClassActorTest methodsFor: 'constants' stamp: 'cwp 9/17/2004 00:45'!
subclassTemplate
	^  'BogusA subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base'''! !

!OBClassActorTest methodsFor: 'constants' stamp: 'cwp 11/30/2004 22:20'!
ownClassNode
	^ OBClassNode on: (Smalltalk at: self class name)! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 12/2/2004 22:43'!
testRenameNoReferences
	| rename newName |
	newName := self class name, 'X'.
	damage addRenameOf: self class name to: newName asSymbol.
	rename := self actionNamed: 'rename...' forNode: self ownClassNode.
	self 
		shouldnt: [[rename trigger] 
					on: OBTextRequest
					do: [:n | n resume: newName]]
		raise: OBBrowseRequest.
! !

!OBClassActorTest methodsFor: 'constants' stamp: ''!
parentNode
	^ self classCatNode! !

!OBClassActorTest methodsFor: 'constants' stamp: ''!
selectedNode
	^ self classNode! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 12/2/2004 23:14'!
testReferences
	| remove |
	remove := self actionNamed: 'browse references' forNode: self classFNode.
	[remove trigger]
		on: OBBrowseRequest
		do: [:n | self assertCorrectBrowser: n browser].
! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 10/17/2004 20:10'!
testCopy
	| rename |
	damage add: #Definition ofClass: #BogusF.
	damage add: #Definition ofClass: #BogusX.
	rename := self actionNamed: 'copy...' forNode: self classFNode.
	[rename trigger]
		on: OBTextRequest
		do: [:n | n resume: 'BogusX'].
	self assert: (Smalltalk hasClassNamed: #BogusF).
	self assert: (Smalltalk hasClassNamed: #BogusX)! !

!OBClassActorTest methodsFor: 'constants' stamp: 'cwp 9/16/2004 15:24'!
nodeLabels
	^ #('remove' 'rename...' 'copy...' 'subclass template')! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 10/17/2004 22:35'!
testRename
	| rename |
	damage addRenameOf: #BogusF to: #BogusX.
	rename := self actionNamed: 'rename...' forNode: self classFNode.
	[rename trigger]
		on: OBInteractionRequest
		do: [:n | n resume: 'BogusX'].
	self deny: (Smalltalk hasClassNamed: #BogusF).
	self assert: (Smalltalk hasClassNamed: #BogusX)! !

!OBClassActorTest methodsFor: 'constants' stamp: ''!
classFNode
	^ OBClassNode on: (Smalltalk at: #BogusF)! !

!OBClassActorTest methodsFor: 'tests' stamp: 'cwp 10/17/2004 20:10'!
testRemove
	| remove |
	damage add: #Definition ofClass: #BogusF.
	remove := self actionNamed: 'remove' forNode: self classFNode.
	[remove trigger]
		on: OBConfirmationRequest
		do: [:n | n resume: true].
	self deny: (Smalltalk hasClassNamed: #BogusF)! !

!OBActorTest methodsFor: 'tests' stamp: ''!
testParentLabels
	| actions |
	actions := self actor actionsForParent: self parentNode.
	self assertActions: actions includeLabels: self parentLabels! !

!OBActorTest methodsFor: 'constants' stamp: ''!
envNode
	^ OBEnvironmentNode forImage! !

!OBActorTest methodsFor: 'constants' stamp: ''!
classCatNode
	^ OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk! !

!OBActorTest methodsFor: 'constants' stamp: ''!
parentLabels
	^ #()! !

!OBActorTest methodsFor: 'constants' stamp: ''!
methCatNode
	^ OBMethodCategoryNode on: 'letters' inClass: BogusA! !

!OBActorTest methodsFor: 'fetching' stamp: ''!
actionNamed: aName forNode: aNode
	| action |
	action := (self actor actionsForNode: aNode) 
				detect: [:ea | ea label = aName].
	action monitor: self.
	^ action! !

!OBActorTest class methodsFor: 'testing' stamp: ''!
isAbstract
	^ self name = #OBActorTest! !

!OBActorTest methodsFor: 'constants' stamp: ''!
classNode
	^ OBClassNode on: (Smalltalk at: #BogusA)! !

OBActor subclass: #OBClassActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Actors'!

!OBClassActor methodsFor: 'actions' stamp: 'cwp 9/17/2004 00:15'!
subclassTemplate: aClassNode 
	| class |
	class _ aClassNode theClass.
	OBDefinitionChanged definition: 
		(OBClassDefinition 
			environment: class environment 
			template: (Class templateForSubclassOf: class category: class category))! !

!OBClassActor methodsFor: 'querying' stamp: 'cwp 12/2/2004 23:09'!
actionsForNode: aClassNode
	^ {OBAction
			label: 'remove' 
			receiver: self
			selector: #remove:
			arguments: {aClassNode}
			keystroke: $x 
			icon: MenuIcons deleteIcon.
		OBAction
			label: 'rename...' 
			receiver: self
			selector: #rename:
			arguments: {aClassNode}.
		OBAction
			label: 'copy...' 
			receiver: self
			selector: #copy:
			arguments: {aClassNode}.
		OBAction
			label: 'subclass template'
			receiver: self
			selector: #subclassTemplate:
			arguments: {aClassNode}.
		OBAction
			label: 'browse references'
			receiver: self
			selector: #browseReferences:
			arguments: {aClassNode}
	}! !

!OBClassActor methodsFor: 'actions' stamp: ''!
copy: aClassNode
	| newName newClass |
	newName := OBTextRequest
			prompt: 'Please type new class name'
			template: aClassNode theNonMetaClassName asString.
	newName ifNotNil:	[newClass := self
										copyClass: aClassNode theNonMetaClass 
										as: newName asSymbol.
						(OBClassNode on: newClass) signalSelection].! !

!OBClassActor methodsFor: 'actions' stamp: ''!
remove: aClassNode
	(OBConfirmationRequest
		prompt: 'Are you certain that you 
want to REMOVE the class ', aClassNode theClassName, ' from the system?'
		confirm: 'Remove')
			ifTrue: [aClassNode theClass removeFromSystem.
					aClassNode signalDeletion]! !

!OBClassActor methodsFor: 'private' stamp: 'cwp 12/5/2004 17:15'!
browseObsoleteRefs: aClassNode as: oldName 
	| binding |
	binding := aClassNode theClass environment 
				associationAt: aClassNode theClass name.
	(SystemNavigation default allCallsOn: binding) isEmpty 
		ifFalse: 
			[OBListBrowser 
				browse: #References
				root: aClassNode
				title: 'Obsolete References to']! !

!OBClassActor methodsFor: 'actions' stamp: 'cwp 11/30/2004 22:05'!
rename: aClassNode
	| newName |
	newName := OBTextRequest
					prompt: 'Please type new class name' 
					template: aClassNode theClassName asString.
	newName ifNotNil:	[ | oldName |
						oldName := aClassNode theNonMetaClass name.
						aClassNode theClass environment 
							renameClassNamed: oldName
							as: newName asSymbol.
						self browseObsoleteRefs: aClassNode as: oldName].
	! !

!OBClassActor methodsFor: 'actions' stamp: 'cwp 12/5/2004 17:15'!
browseReferences: aClassNode 
	OBListBrowser 
		browse: #References
		root: aClassNode copy
		title: 'References to'! !

!OBClassActor methodsFor: 'private' stamp: ''!
copyClass: oldClass as: newName
	| oldDefinition newDefinition newClass |
	(oldClass environment hasClassNamed: newName)
		ifTrue: [^self error: newName, ' already exists'].
	oldDefinition := oldClass definition.
	newDefinition := oldDefinition 
						copyReplaceAll: '#' , oldClass name asString 
						with: '#' , newName asString.
	Cursor wait 
		showWhile: [newClass := Compiler evaluate: newDefinition logged: true.
					newClass copyAllCategoriesFrom: oldClass.
					oldClass class copyAllCategoriesFrom: oldClass class].
	^ newClass! !

OBActor subclass: #OBCategoryActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Standard-Actors'!

!OBCategoryActor methodsFor: 'actions' stamp: 'cwp 9/23/2004 23:28'!
createIn: anOrganization
	| catName |
	catName := OBTextRequest 
					prompt: 'Please type new category name' 
					template: (self categoryTemplateFor: anOrganization).
	catName ifNotNil:	[anOrganization addCategory: catName.
						(OBClassCategoryNode on: catName) signalSelection]! !

!OBCategoryActor methodsFor: 'actions' stamp: 'cwp 9/22/2004 21:09'!
reorganizeCategoriesIn: anOrganizer
	^ OBDefinitionChanged definition: (OBOrganizationDefinition on: anOrganizer)! !

!OBCategoryActor methodsFor: 'actions' stamp: ''!
alphabetizeCategoriesIn: anOrganizer 
	anOrganizer sortCategories.
	OBListChanged signal! !

!OBCategoryActor methodsFor: 'actions' stamp: 'cwp 9/18/2004 22:53'!
categorizeIn: aClassOrganizer 
	"Categorize methods by looking in parent classes for a method category."
	| organizers |
	organizers := aClassOrganizer subject withAllSuperclasses collect: [:ea | ea organization].
	(aClassOrganizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found := (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [aClassOrganizer classify: sel under: found]]! !

!OBCategoryActor methodsFor: 'queries' stamp: 'cwp 9/18/2004 23:59'!
actionsForParent: aNode
	| actions |
	actions _ self stdActionsForParent: aNode.
	aNode organization 
			isClassOrganizer ifTrue: [actions _ actions copyWith: (self categorizeActionFor: aNode)].
	^ actions! !

!OBCategoryActor methodsFor: 'actions' stamp: ''!
rename: aNode
	| category |
	category := OBTextRequest
				prompt: 'Please type new category name' 
				template: aNode name.
	category ifNotNil:	
		[aNode container organization renameCategory: aNode name toBe: category.
		OBListChanged signal]! !

!OBCategoryActor methodsFor: 'actions' stamp: 'cwp 9/19/2004 00:11'!
remove: aNode
	| list choice |
	list := aNode container organization listAtCategoryNamed: aNode name.
	list isEmpty ifTrue: [^ aNode remove].
	choice := OBConfirmationRequest prompt: 'Are you sure you want to
remove this category 
and all its elements?' confirm: 'Remove'.
	choice ifTrue: [^ aNode remove]! !

!OBCategoryActor methodsFor: 'actions' stamp: 'cwp 9/18/2004 21:55'!
removeEmptyCategoriesIn: anOrganizer 
	anOrganizer removeEmptyCategories! !

!OBCategoryActor methodsFor: 'private' stamp: 'cwp 9/23/2004 23:29'!
categoryTemplateFor: anOrganization
	^ anOrganization isClassOrganizer
		ifTrue: ['category name']
		ifFalse: ['Category-Name']! !

!OBCategoryActor methodsFor: 'queries' stamp: 'cwp 9/22/2004 20:58'!
stdActionsForParent: aNode
	^ Array
		with: (OBAction 
				label: 'create category...'
				receiver: self
				selector: #createIn:
				arguments: (Array with: aNode organization)
				icon: MenuIcons newIcon)
		with: (OBAction
				label: 'alphabetize categories'
				receiver: self
				selector: #alphabetizeCategoriesIn:
				arguments: (Array with: aNode organization))
		with: (OBAction
				label: 'remove empty categories'
				receiver: self
				selector: #removeEmptyCategoriesIn:
				arguments: (Array with: aNode organization))
		with: (OBAction
				label: 'reorganize categories'
				receiver: self
				selector: #reorganizeCategoriesIn:
				arguments: (Array with: aNode organization))
! !

!OBCategoryActor methodsFor: 'queries' stamp: 'cwp 9/18/2004 23:52'!
categorizeActionFor: aNode
	^ OBAction
		label: 'categorize automatically'
		receiver: self
		selector: #categorizeIn:
		arguments: (Array with: aNode organization)! !

!OBCategoryActor methodsFor: 'queries' stamp: ''!
actionsForNode: aNode
	^ Array
		with: (OBAction
				label: 'remove'
				receiver: self
				selector: #remove:
				arguments: {aNode}
				keystroke: $x
				icon: MenuIcons deleteIcon)
		with: (OBAction
				label: 'rename...'
				receiver: self
				selector: #rename:
				arguments: {aNode})! !
OBCodeGraphInitializer initialize!
OBSystemBrowserAdaptor initialize!
OBSystemBrowser initialize!
